import re
from numpy import log2


def get_error(fn):
    lines = open(fn).readlines()
    err = [float(re.search("L2Err (.*) max",line).group(1)) for line in lines]
    return err

if __name__== "__main__":
    maxdeg= 1
    dt = 0.001
    T = 1
    plot = 1
    minlevel = 2
    maxlevel = 4
    S = ""
    for deg in range(1, maxdeg+1):
        norms =[]
        for level in range(minlevel, maxlevel+1):
            errs_unsort = get_error("L2Errors_dt_" + str(dt) + "__deg_" + str(deg) + "__level_" + str(level) + ".txt")
            squaresum = sum(list(map(lambda x: x*x, errs_unsort[1:-1])))
            squaresum += 0.5*(errs_unsort[1]*errs_unsort[1]+errs_unsort[-1]*errs_unsort[-1])
            squaresum *= dt
            norms.append(squaresum**(1/2))
            
        S += "error norms for degree=" + str(deg) + "\n"
        
        #print("error norms for degree=" + str(deg))
        normstr = ["{:.3e}".format(n) for n in norms]
        S+= " ".join(normstr) + "\n"
        #print(" & ".join(normstr))
        rates = ["{:.2f}".format(log2(e1/e2)) for e2, e1 in zip(norms[1:], norms[:-1])]
        S += " ".join(rates) + "\n"
        #print(" & ".join(rates))
    print(S)


