import os
import shutil

MPP_PATH = os.environ["HOME"] + "/FWI_RHS/"

MPP_COMMAND = f"cd {MPP_PATH}; mpirun -n 64 fwi fwiVAcoustic_conv_benchmark_current"

tpl_fn = MPP_PATH + "FWI/conf/fwiVAcoustic_conv_benchmark_TPL"
conf_fn = MPP_PATH + "FWI/conf/fwiVAcoustic_conv_benchmark_current.conf"
tpl = open(tpl_fn, "r").read()

degs = [1, 2, 3]
lvls = [1, 2, 3]
dts = [1e-5 * 2**i for i in range(10)][::-1]

print("degs: ", degs)
print("dts:  ", dts)
print("lvls: ", lvls)

for deg in degs:
    for lvl in lvls:
        for dt in dts:
            print()
            print("----------------------------------")
            print(f"deg: {deg};   lvl: {lvl};   dt: {dt}")

            cur_conf = tpl.format(deg=deg, level=lvl, dt=dt)
            open(conf_fn, "w").write(cur_conf)
            print("running", MPP_COMMAND)
            os.system(MPP_COMMAND)
