#ifndef FWIINTEGRALOPERATORPRECONDITIONER_H_
#define FWIINTEGRALOPERATORPRECONDITIONER_H_

#include "Preconditioner.hpp"
#include "FWITimeSolver.hpp"
//#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "FWIDGVAcousticMaterialFromVector.hpp"
#include "DGVAcousticAssembleCombined.hpp"

#include <memory>

class AAOIntegralPrecon : public Preconditioner {
    const Vector &WaveVec;
    std::shared_ptr<DGVAcousticAssembleCombined> assembleFWD = nullptr;
    std::shared_ptr<DGVAcousticAssembleCombined> assembleBWD = nullptr;
    const EleCacheType &eleCache;
    Matrix Mass;
    std::unique_ptr<LinearSolver> solvIM;
public:
    AAOIntegralPrecon(const Vector &WaveVec_, PMLHandlerAAO *pmlh_,
                      const EleCacheType &eleCache, const Vector &MatVec, const WaveProblemDGTSVA &prob);

    ~AAOIntegralPrecon() override = default;


    void Construct(const Matrix &) override {}

    void Destruct() override {}

    void multiply2(Vectors &u, const Vectors &b, bool fwd) const;

    void multiply(Vectors &u, const Vectors &b) const override;

    void multiply_transpose(Vectors &u, const Vectors &b) const override;

    std::string Name() const override { return "AAOPrecon"; }
};

#endif
