//
// Created by cr on 14.10.21.
//

#include "FWILinearizedIntegralOperator.hpp"

void FWILinearizedIntegralOperator::Evaluate(const Vector &materialDirection,
                                             Vectors &LinearizedEvaluation) const {
  Vector tmp(0.0, LinearizedEvaluation[0]);
  Vector tmp2(0.0, LinearizedEvaluation[0]);
  if (discrete_) {
    APrime = std::make_unique<Matrix>(LinearizedEvaluation[0]);
    linAssembler.assembleLinearizedFluxMatrix(materialDirection, *APrime);
  }
  for (int timeStep = 0; timeStep < LinearizedEvaluation.size(); ++timeStep) {
    tmp = WaveFieldPoint[timeStep];
    linAssembler.MPrimeMatVec(materialDirection, VecsInte.integrateOneStepAndGetVector(), tmp);
    if (discrete_) {
      tmp2 = VecsInte.GetIntegratedVec();
      tmp2.Accumulate();
      tmp -= (*APrime) * tmp2;
    }
    LinearizedEvaluation[timeStep] = tmp;
  }
  VecsInte.Reset();
}

FWILinearizedIntegralOperator::FWILinearizedIntegralOperator(std::shared_ptr<WaveProblemDGTSVA> problem_fwd_,
                                                             const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
                                                             const Vector &materialPoint_,
                                                             const Vectors &WaveFieldPoint_,
                                                             double dt, int rkorder, bool discrete)
        :
        linAssembler(problem_fwd_, eleCache_, materialPoint_),
        VecsInte(WaveFieldPoint_, dt, rkorder),
        WaveFieldPoint(WaveFieldPoint_),
        discrete_(discrete) {
}
