//
// Created by cr on 14.10.21.
//

#ifndef FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP
#define FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP


#include "Assembler/FWILinearizedAssembler.hpp"
#include "VectorsIntegrator.hpp"

class FWILinearizedIntegralOperator {
  mutable std::unique_ptr<Matrix> APrime = nullptr;
  const Vectors &WaveFieldPoint;
  bool discrete_ = false;
  FWILinearizedAssembler linAssembler;
  VectorsIntegrator VecsInte;
public:
  FWILinearizedIntegralOperator(std::shared_ptr<WaveProblemDGTSVA> problem_fwd_,
                                const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
                                const Vector &materialPoint_,
                                const Vectors &WaveFieldPoint_,
                                double dt,
                                int rkorder,
                                bool discrete);

  FWILinearizedIntegralOperator(const Vector &materialPoint_,
                                const Vectors &WaveFieldPoint_,
                                const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
                                std::shared_ptr<WaveProblemDGTSVA> problem_fwd_)
      :
      linAssembler(problem_fwd_, eleCache_, materialPoint_),
      VecsInte(WaveFieldPoint_),
      WaveFieldPoint(WaveFieldPoint_) {
    Config::Get("discrete", discrete_);
  }

  void Evaluate(const Vector &materialDirection,
                Vectors &LinearizedEvaluation) const;

};


#endif //FWI_FWILINEARIZEDINTEGRALOPERATOR_HPP
