//
// Created by cr on 24.08.22.
//

#ifndef FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP
#define FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP


#include "DGVAcousticRHSAssembler.hpp"
#include "Observation/FWISeismogram.hpp"
#include "Observation/FWIObservationDGTSNEW.hpp"
#include "Observation/FWIObservationSpecification.hpp"

class DGVAcousticRHSAssemblerAdjoint : public DGVAcousticRHSAssembler {
    mutable const FWISeismogram *Seis{};
    double dt;
    double T;
    const FWIObservationSpecification &Spec;
    const FWIObservationOperatorNEW &Obs;
public:
    explicit DGVAcousticRHSAssemblerAdjoint(const FWIObservationOperatorNEW &Obs);

    void Initialize(Vector &u) const override;

    void setSeis(const FWISeismogram *s) const;

    void RHS(double t_, Vector &b) const override;
};


#endif //FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP
