//
// Created by cr on 21.11.22.
//

#include "FWIRhsFromVectorsVA.hpp"
//
// Created by cr on 21.11.22.
//

#include "FWIRhsFromVectorsVA.hpp"

FWIRhsFromVectorsVA::FWIRhsFromVectorsVA(const Vectors &_residual, const std::unordered_map<Point,
        DGAcousticElement *> &ElementCache_, double dt_, bool mp)
        :
        residual_mp(_residual.size(), _residual[0]), eleCache(ElementCache_), dt(dt_) {
    if (mp) {
        residual_mp = 0.0;
        for (int i = 0; i < residual_mp.size() - 1; ++i) {
            residual_mp[i] = _residual[i];
            residual_mp[i] += _residual[i + 1];
            residual_mp[i] *= 0.5;
        }
    } else {
        residual_mp = _residual;

    }
}

VectorField FWIRhsFromVectorsVA::ForceV(double t, const Cell &c, const Point &, int q) const {
    int time = static_cast<int>(floor(t / dt));
    auto &elem = eleCache.at(c());
    VectorField ret = elem->Velocity(q, residual_mp[time]);

    return ret;
}

double FWIRhsFromVectorsVA::ForceP_i(double t, const Cell &c, const Point &, int n, int q) const {
    int time = static_cast<int>(floor(t / dt));
    auto &elem = eleCache.at(c());
    return elem->Pressure_i(q, residual_mp[time], n);
}
