//
// Created by cr on 21.11.22.
//

#ifndef FWI_FWIRHSFROMVECTORSVA_HPP
#define FWI_FWIRHSFROMVECTORSVA_HPP

#include "Vector.hpp"
#include "FWIAbstractInterfaceDGTSVA.hpp"

class FWIRhsFromVectorsVA : public FWIRhsVAcoustic {
    Vectors residual_mp;
    double dt;
    const std::unordered_map<Point, DGAcousticElement *> &eleCache;
public:
    FWIRhsFromVectorsVA(const Vectors &, const std::unordered_map<Point, DGAcousticElement *> &, double,
                        bool mp = true);

    bool RHS(double) const override { return true; }

    VectorField ForceV(double t, const Cell &c, const Point &, int q) const override;

    double ForceP_i(double t, const Cell &c, const Point &, int n, int q) const override;
};

#endif //FWI_FWIRHSFROMVECTORSVA_HPP
