#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "FWIProblemWrapperVA.hpp"


void FWIMaterialVAcousticDGTS::setParametrization(string s) {
    parametrization = s;
    if (s == "native") {
        paramComps = 2 + 2 * numL;
        para = 0;
    } else if (s == "taup" || s == "taup_positive") {
        if (numL == 0) {
            paramComps = 2;
        } else {
            paramComps = 3 + numL;
        }
        para = 1;
    }
}

double FWIBndConditionsVAcoustic::Neumann(double t, const Cell &C,
                                          const Point z, const VectorField &N) const {
    VectorField V = zero;
    for (int i = 0; i < dim; ++i) {
        V[i] = ut(t, C, z, i);
    }
    return V * N;
}
