//
// Created by cr on 23.08.22.
//

#ifndef FWI_FWIDGVACOUSTICMATERIALFROMVECTOR_HPP
#define FWI_FWIDGVACOUSTICMATERIALFROMVECTOR_HPP


#include "DGVAcousticMatrixAssembler.hpp"
#include "FWIAbstractInterfaceDGTSVA.hpp"

class FWIDGVAcousticMaterialFromVector : public DGVAcousticMaterialFromVector {
    std::unique_ptr<Vector> TauP = nullptr;
  const WaveProblemDGTSVA &prob;
    void fillVector(const WaveProblemDGTSVA &problem_fwd, const Vector &Mat);
 PMLHandler* handle=nullptr;
  PMLHandlerAAO* handleAAO=nullptr;
public:
    FWIDGVAcousticMaterialFromVector(const WaveProblemDGTSVA &prob, const Vector &Mat,
                                     PMLHandler *handle_ = nullptr,
                                     PMLHandlerAAO *handleAAO_ = nullptr);
    double alpha(const Cell & C,
                       const Point & x) const override{
    return prob.alpha(C,x);
  }
   double alpha1() const override{

    return prob.alpha1();
  }
   double alpha2() const override {
    return prob.alpha2();
  }
    double Rho(const Cell &C, const Point &) const override;

    double Kappa_i(const Cell &C, const Point &, int n) const override;

    double invKappa_i(const Cell &C, const Point &, int n) const override;

    double invTau_i(const Cell &C, const Point &, int n) const override;

    double Kappa(const Cell &C, const Point &x) const override;
};

#endif //FWI_FWIDGVACOUSTICMATERIALFROMVECTOR_HPP
