#include "ForwardModels/FWIForwardModelDGTSVAAllAtOnce.hpp"
#include "m++.hpp"
#include "Assembler/FWILinearizedAssembler.hpp"
#include "Problems/FWIInversionProblems.hpp"

double my_uniform_rand(double a, double b) {
  return a + (b - a) * ((static_cast<double>(rand()) / RAND_MAX));
}

void bla(Vector &mDirec, Vector &Material) {
  Vector tmp(Material);
  const Mesh &M = mDirec.GetMesh();
  tmp += mDirec;
  for (cell c = mDirec.cells(); c != mDirec.cells_end(); ++c) {
    double alpha = 0.5;
        int numL = 1;
        for (int f=0; f<c.Faces(); ++f) {
            if (M.OnBoundary(*c, f)) {
                continue;
            } else {
                cell cf = M.find_neighbour_cell(c, f);

                double rhoDK = mDirec(c(), 0);
                double vDK = mDirec(c(), 1);
                double taupDK = mDirec(c(), 2);
                double rhoK = Material(c(), 0);
                double vK = Material(c(), 1);
                double taupK = Material(c(), 2);
            double rhoDKf = mDirec(cf(),0);
            double vDKf   = mDirec(cf(),1);
            double taupDKf = mDirec(cf(),2);
            double rhoKf = Material(cf(),0);
            double vKf   = Material(cf(),1);
            double taupKf = Material(cf(),2);
            double rhoK2 = tmp(c(),0);
                double vK2 = tmp(c(), 1);
                double taupK2 = tmp(c(), 2);
                double rhoKf2 = tmp(cf(), 0);
                double vKf2 = tmp(cf(), 1);
                double taupKf2 = tmp(cf(), 2);
                double zK2 = zKTauPositive(numL, alpha, rhoK2, vK2, taupK2);
                double zKf2 = zKTauPositive(numL, alpha, rhoKf2, vKf2, taupKf2);
                double zK = zKTauPositive(numL, alpha, rhoK, vK, taupK);
                double zKPrime = zKPrimeTauPositive(numL, alpha, rhoK, vK, taupK, rhoDK, vDK, taupDK);
                double zKf = zKTauPositive(numL, alpha, rhoKf, vKf, taupKf);
                double zKfPrime = zKPrimeTauPositive(numL, alpha, rhoKf, vKf, taupKf,
                                                     rhoDKf, vDKf, taupDKf);

                mout << OUT(rhoK) << OUT(rhoK2) << OUT(vK) << OUT(vK2) << OUT(taupK) << OUT(taupK2) << endl;
                mout << OUT(zK) << OUT(zK2) << endl;
                double Diff = zK2 - zK;
                mout << OUT(Diff - zKPrime) << endl;


                double alpha1 = 1.0 / (zK + zKf);
                double alpha12 = 1.0 / (zK2 + zKf2);
                double alpha1Prime = -alpha1 * alpha1 * (zKPrime + zKfPrime);
//            mout << OUT(alpha1) << OUT(alpha12) << endl;
//            mout << OUT(alpha12-alpha1)<< endl;
//            mout << OUT(alpha1Prime)<< endl;
//            double alpha2Prime =  zKPrime*zKf*alpha1 + zK*zKfPrime*alpha1
//                    + zK*zKf*alpha1Prime;
//            double alpha3Prime = zKfPrime*alpha1 + zKf * alpha1Prime;
//            double alpha4Prime = zKPrime*alpha1 + alpha1Prime*zK;
            }
        }
    }
}
void MatrixTestLinearized() {
    auto meshes = MeshesCreator().CreateShared();
    WPConf Conf;
    LevelPair lev{Conf.level, -1};
    std::unique_ptr<FWIForwardModelDGTSVA> FWD(new FWIForwardModelDGTSVA(meshes, lev, 0, nullptr));

    auto problem = GetInversionProblem(Conf);
    FWD->setProblem(problem);
    Vector MVec(FWD->GetMatVec());
    MVec.Clear();
    Vector MVec2(MVec);
    Vector tmp(MVec);
    Vector tmp2(MVec);
//    srand(time(nullptr));
    srand(42);
    for (cell c = MVec.cells(); c != MVec.cells_end(); ++c) {
        MVec(c(), 0) = log(2000);
        MVec(c(), 1) = log(3500);
        MVec(c(), 2) = log(0.02);


    }
    tmp =0.0;
    for(cell c=MVec.cells(); c!=MVec.cells_end(); ++c){
        tmp(c(),0) = log(my_uniform_rand(0,200));
        tmp(c(),1) = log(my_uniform_rand(0,350));
        tmp(c(),2) = log(my_uniform_rand(0,0.02));
//        tmp(c(),0) = log(200);
//        tmp(c(),1) = log(350);
//        tmp(c(),2) = log(0.02);
    }
    std::shared_ptr<DGAssemble> fwd1(FWD->getDGAssemble(MVec, *problem, *problem, true));
    Vector U(FWD->GetWaveVec());

    Matrix FluxFwd1(U);
    fwd1->FluxMatrix(FluxFwd1);
    Matrix FluxFwd2(U);
    Matrix FluxLin(U);
    for (int i=0; i < 8; ++i){
        double h = pow(0.1,i);
        tmp2 = tmp;
      tmp2 *= h;
      MVec2 = MVec;
      MVec2 += tmp2;
      mout << "tmp2 Norm: " << PPM->Sum(tmp2.norm()) << endl;
      mout << "tmp2 Norm: " << tmp2.norm() << endl;
        std::shared_ptr<DGAssemble> fwd2(FWD->getDGAssemble(MVec2, *problem, *problem, true));
      fwd2->FluxMatrix(FluxFwd2);

      mout << "Ohne H: " << FluxFwd1.norm() << endl;
      mout << "Plus H: " << FluxFwd2.norm() << endl;
      FWILinearizedAssembler assembler((*FWD).problem_fwd, (*FWD).eleCacheContainer->Get(), MVec);
      assembler.assembleLinearizedFluxMatrix(tmp2, FluxLin);

        mout << "Lin: " << FluxLin.norm() << endl;
        FluxFwd2.GetData() -= FluxFwd1.GetData();
        mout << "Diff: " << FluxFwd2.norm() << endl;
        FluxFwd2.GetData() -= FluxLin.GetData();
        mout << "Final:  " << FluxFwd2.norm() / tmp2.norm() << endl;
        //TODO Constructor of RMatrix with Matrix.?
//        mout << RMatrix(FluxFwd2) << endl;
    }
    Exit("CIAO");
    Config::Get("level", Conf.level);
//    LevelPair lev{level,-1};
    std::unique_ptr<FWIForwardModelDGTSVAAllAtOnce> FWDAAO(
            new FWIForwardModelDGTSVAAllAtOnce(meshes, lev, 0, nullptr));
    FWDAAO->setProblem(problem);
    std::shared_ptr<DGAssemble> assembleAAO1(FWDAAO->getDGAssemble(MVec, *problem, *problem, true));

    Matrix Mat(U);
    assembleAAO1->MassMatrix(Mat);
    Matrix MatH(U);
    Matrix MatLin(U);
    for (int i = 0; i < 12; ++i) {
        double h = pow(0.1, i);
        tmp2 = tmp;
        tmp2 *= h;
        MVec2 = MVec;
        MVec2 += tmp2;
        mout << "tmp2 Norm: " << tmp2.norm() << endl;
        std::shared_ptr<DGAssemble> assembleAAO2(FWDAAO->getDGAssemble(MVec2, *problem, *problem, true));
        assembleAAO2->MassMatrix(MatH);
        mout << "Ohne H: " << Mat.norm() <<endl;
        mout << "Plus H: " << MatH.norm() << endl;
//        (*FWDAAO).assembleMPrime(tmp2,MVec,MatLin);
        mout << "Lin: " << MatLin.norm() << endl;
        MatH.GetData() -= Mat.GetData();
        mout <<"Diff: " << MatH.norm() << endl;
        MatH.GetData() -=MatLin.GetData();
        mout << "Final:  " << MatH.norm()/tmp2.norm() << endl;
    }

}

