#ifndef _FWIMPPHELPERS_H_
#define _FWIMPPHELPERS_H_

#include "m++.hpp"
#include "ForwardModels/FWIForwardModel.hpp"
#include <iomanip>


// ------------------------------------------------------------
// Subject to change

typedef RVector FWIState;


double zKTauPositive(int numL, double alpha, double rhoK, double vK, double taupK);

double zKPrimeTauPositive(int numL, double alpha, double rhoK, double vK, double taupK, double rhoDK, double vDK,
                          double taupDK);

double zKTau(int numL, double alpha, double rhoK, double vK, double taupK);

double zKPrimeTau(int numL, double alpha, double rhoK, double vK,
                  double taupK, double rhoDK, double vDK, double taupDK);

static Point Neighbor(const Mesh &M, const Cell &c, int i) {
    face f = M.find_face(c.Face(i));
    if (f.Right() == c())
        return f.Left();
    else
        return f.Right();
}

std::list<Point> PointsOnLine(vector<Point> &waypoints, vector<int> &nrOfPointsOnLine, bool include_last_waypoint);

void
ReadWaypoints(const std::string &Wpname, int &WpCount, std::vector<Point> &WpPoints,
              std::vector<int> &nrPointsBetween, bool &includeWaypoints);

#endif
