//
// Created by cr on 09.11.22.
//

#ifndef FWI_FWITIMESOLVER_HPP
#define FWI_FWITIMESOLVER_HPP

#include "Vector.hpp"
#include "Assemble.hpp"
#include "Observation/FWISeismogram.hpp"
#include "PMLHandler.hpp"
#include "Observation/FWIObservationDGTSNEW.hpp"

class FWITimeSolver {
    const std::shared_ptr<PMLHandler> &PMLH;
    int rkorder = -2;
    const Vector &WaveVectorUnpadded;
public:
    FWITimeSolver(const Vector &wVU, const std::shared_ptr<PMLHandler> &PMLH_, int rkorder_) :
            WaveVectorUnpadded(wVU), PMLH(PMLH_), rkorder(rkorder_) {}

    void SolveAndMeasure(const std::shared_ptr<ILinearTimeAssemble> &assemble,
                         const FWIObservationOperatorNEW &Obs,
                         FWISeismogram &s, Vectors *U_m);

    void Solve(const std::shared_ptr<ILinearTimeAssemble> &assemble, Vectors &U_m);

};


#endif //FWI_FWITIMESOLVER_HPP
