//
// Created by cr on 14/03/23.
//

#include "FWIForwardModelDGTSVANormalized.hpp"
void FWIForwardModelDGTSVANormalized::AdjointLinearized(const FWIDataContainerDomain &nonlinearPoint,
                                              const FWISubproblem &adjointLinearizedPoint,
                                              FWIDataContainerDomain &adjointLinearizedEvaluation) {
  FWIDataContainerDomain tmp(getReconstructionType(), GetMatVec(), GetWaveVec(), TConf.timeSteps);
  for (size_t i = 0; i < uM.size(); ++i) {
    AdjOp->CalculateAdjoint(adjointLinearizedPoint[i].getSeismogram(), tmp.getMatWrite(), nullptr);
    adjointLinearizedEvaluation.getMatWrite() += tmp.getMat();
  }
  if (Taper) {
    Taper->ApplyTaperVector(adjointLinearizedEvaluation.getMatWrite());
    Taper->ApplyMinMaxTaper(adjointLinearizedEvaluation.getMatWrite(),*problem_fwd);
  }  adjointLinearizedEvaluation.getMatWrite().MakeAdditive();
}

void FWIForwardModelDGTSVANormalized::Linearized(const FWIDataContainerDomain &nonlinearPoint,
                                       const FWIDataContainerDomain &linearizedPoint,
                                       FWISubproblem &linearizedEvaluation) {
  for (size_t i = 0; i < uM.size(); ++i) {
    LinOp->SolveAndMeasure(linearizedPoint.getMat(), *Obs, linearizedEvaluation[i]
        .getSeismogramWrite(), nullptr);
  }

}

void FWIForwardModelDGTSVANormalized::calculateDefect(const vector<FWIDataContainerRange> &data_obs,
                                            const FWISubproblem &nonlinearEvaluation, FWISubproblem &defect,
                                            std::vector<int> subproblem) {
  defect.resize(subproblem.size(),
                FWIDataContainerRange(data_obs[0].getSeismogram()));
  if (subproblem.size() > 1) Exit("Check this for bigger subproblems!")
  for (size_t i = 0; i < subproblem.size(); ++i) {
    FWISeismogram tmp = data_obs[subproblem[i]].getSeismogram();
    NormalizeTracewise(tmp);
    defect[i].getSeismogramWrite() = tmp;
    defect[i].getSeismogramWrite() -= nonlinearEvaluation[i].getSeismogram();
  }
}
