//
// Created by cr on 24/03/23.
//

#ifndef FWI_FWIFORWARDMODELDGTSVASO_HPP
#define FWI_FWIFORWARDMODELDGTSVASO_HPP


#include "FWIForwardModelDGTSVA.hpp"
#include "Reduced/FWILinOpRedSecondOrder.h"
#include "Reduced/FWILinOpAdjRedSecondOrder.h"

class FWIForwardModelDGTSVASO : public FWIForwardModelDGTSVA {
public:
    FWIForwardModelDGTSVASO(std::shared_ptr<Meshes> meshes, LevelPair lev, int deg,
    const std::shared_ptr<WaveProblemDGTSVA> &problem_fwd) : FWIForwardModelDGTSVA(meshes, lev, deg, problem_fwd) {};

    //Psi(p_k) [.] = Phi(p_k)[.] + 1/2 Phi(p_k)[s_k, .]
    void ChangeLinearized(const FWIDataContainerDomain &hk, const std::vector<int> subprobProb){
//        std::cout << "---- Start to change Operators to Psi" << std::endl;
        if (subprobProb.size() > 1) Exit("This Part (ChangeLinearized in ..DGTSVASO) does not match architecture for bigger subproblems yet.")
        AdjOp = std::make_unique<FWILinOpAdjRedSecondOrder>(*(uM[0]), dynamic_cast<FWILinOpRedFirstOrder *>(&(*LinOp))->getM(),
                                                            hk.getMat(),*Obs, problem_fwd, PMLH, TConf, recon,
                                                            eleCacheContainer->Get(), true);

//        std::cout << "---- Adjoint done, LinOp to go" << std::endl;
        LinOp = std::make_unique<FWILinOpRedSecondOrder>(*(uM[0]), dynamic_cast<FWILinOpRedFirstOrder *>(&(*LinOp))->getM(),
                                                         hk.getMat(), problem_fwd, PMLH, TConf,
                                                         eleCacheContainer->Get(),false, true);
//        std::cout << "---- Done Changing Operators to Psi" << std::endl;
    }
};


#endif //FWI_FWIFORWARDMODELDGTSVASO_HPP
