//
// Created by cr on 14.10.21.
//

#ifndef FWI_GRAMIANBLOCKINVERSE_HPP
#define FWI_GRAMIANBLOCKINVERSE_HPP


#include <Matrix.hpp>
#include <SparseRMatrix.hpp>
#include "DGElement.hpp"
#include "DGAcousticElement.hpp"

void assembleScalarProductMatrix(Matrix &M,
                                 const std::unordered_map<Point, DGAcousticElement *> &eleCache);

RMatrix getRMatrixFromCell(const Matrix &A, const Cell &C);

class GramianBlockInverse {
    const std::unordered_map<Point, DGAcousticElement *> &eleCache;

    void productOneCellScalarProductInverse(const Vector &u, const DGAcousticElement &elem, Vector &b) const;

    void productOneCellSparse(const Vector &u, const SparseRMatrix &SpSm, int Row, Vector &b) const;

    std::shared_ptr<Matrix> scalarProductMatrix = nullptr;
    std::unordered_map<double, SparseRMatrix> ScalarMInverse;
public:
    GramianBlockInverse(std::shared_ptr<Matrix> scalarProductMatrix_,
                        const std::unordered_map<Point, DGAcousticElement *> &eleCache);

    GramianBlockInverse(std::unordered_map<Point, DGAcousticElement *> &eleCache);

  void scalarProductInverse2(const Vector &u, Vector &b) const;

  void scalarProductInverse2(Vectors &b) const {
    for (size_t i = 0; i < b.size(); ++i) {
      scalarProductInverse2(b[i]);
    }
  }

  void scalarProductInverse2(Vector &b) const;

  const SparseRMatrix &at(double a) {
    return ScalarMInverse.at(a);
  }

};


#endif //FWI_GRAMIANBLOCKINVERSE_HPP
