// $Header: /public/M++/Fruitfly/src/Main.C,v 1.29 2011-09-30 16:08:44 wieners Exp $
//#include "m++.hpp"
#include "m++.hpp"
#include "Parallel.hpp"
#ifdef COMPLEX
#error undef COMPLEX in src/Compiler.h
#endif
typedef std::vector<std::vector<double>> NonlinearOutput;


void FWIForwardMain();

NonlinearOutput FWIInverseMainDGTSVA();

void FWICreateSeismogramDGTS();
void TOAST();
void FWICreateSeismogram_SummerSchoolDGTS();

void FWIInverseVTKCalcs();

void FWITimeConv();

void FWICalcSeismogramsFromVTK();

void AFFE();

int createKernels2();

int main(int argc, char **argv) {
    Config::SetConfPath("../FWI/conf/");
    Config::SetGeoPath("../FWI/conf/geo/");
    Config::SetConfigFileName("m++.conf");
    Mpp::initialize(&argc, argv);
    std::string Model = "FWIForward";
    Config::Get("Model", Model);
    bool testAAO = false;
    Config::Get("testAAO", testAAO);

    if (Model == "FWIInverse_DGTS") {
        std::string FWD = "VADGTS";
        Config::Get("ForwardSolver", FWD);
        std::string ReconstructionType = "Classical";
        Config::Get("ReconstructionType", ReconstructionType);
        if (FWD == "VADGTS") {
                    NonlinearOutput lel = FWIInverseMainDGTSVA();
                for (int prob = 0; prob < lel.size(); prob++) {
                    mout << lel[prob] << endl;
            }
        }
    } else if (Model == "FWICreateSeismogramDGTS") FWICreateSeismogramDGTS();
    else if (Model == "FWICalcSeismogramsFromVTK") FWICalcSeismogramsFromVTK();
    else if (Model == "AFFE") AFFE();
    else if (Model == "createKernels") createKernels2();
    else Exit("not implemented!");
    return 0;
}


