#ifndef _NONLINEAROPTIONS_H_
#define _NONLINEAROPTIONS_H_
class ReginnOptions {
public:
    int regularizationStrategy = 0;
    int maxInnerLoopSteps = 10;
    double gamma = 0.9;
  double thetaMax = 0.9999999999;
  double thetaInitial = 0.4;
    double damping = 1.0;

    ReginnOptions() = delete;

    ReginnOptions(std::string &name) {
        Config::Get("FWI_MaxInnerLoopSteps_" + name, maxInnerLoopSteps);
        Config::Get("FWI_Gamma_" + name, gamma);
        Config::Get("FWI_Damping_" + name, damping);
        Config::Get("FWI_ThetaMax_" + name, thetaMax);
        Config::Get("FWI_ThetaInitial_" + name, thetaInitial);
        Config::Get("FWI_RegularizationStrategy_" + name, regularizationStrategy);
    }
};

class NonlinearGeneralOptions {
public:
    int hierarchyLevel = -1;
    bool saveAdjointWF = false;
    bool FWIprecon = false;
    bool saveSeis = false;
    int plotLevel = 0;
    double backtrackingFactor = 0.5;
    bool backtrackingActivated = false;
    std::string parametrization = "native";

    NonlinearGeneralOptions(std::string name) {
        Config::Get("FWI_Precon", FWIprecon);
        Config::Get("FWI_HierarchyLevel", hierarchyLevel);
        Config::Get("FWI_SaveAdjointWF", saveAdjointWF);
        Config::Get("FWI_SaveSeis", saveSeis);
        Config::Get("FWI_DebugPlottingLevel", plotLevel);
        Config::Get("FWI_BacktrackingFactor", backtrackingFactor);
        Config::Get("FWI_BacktrackingActivated", backtrackingActivated);
        Config::Get("parametrization", parametrization);
    }
};

#endif
