#include "DeltaKernels.hpp"



FWIDeltaFunctionConstant::FWIDeltaFunctionConstant(int _dim, const Point &center, double radius,
                                                   const vector<Point> *_midPoints, int _exponent)
        : FWIDeltaKernel(_dim, center, radius, _midPoints, _exponent) {
    Exit("dont use this plx");
    if (dim == 1) {
        normconst = radius;
    } else if (dim == 2) {
        normconst = radius * radius;
    } else if (dim == 3) {
        Exit("dimension 3 not implemnted in measurekernel");
    } else {
        Exit("no dimension specified... dim value: " + std::to_string(dim));
    }
    normconst /= midPoints->size();
}
double FWIDeltaFunctionConstant::operator() (const Point&,const Cell& ce) const {
    for (auto i = midPoints->begin(); i != midPoints->end(); ++i) {
        if (*i == ce()) {
            return 1.0 / normconst;
        }
    }
    return 0.0;
}

FWIDeltaFunctionGauss::FWIDeltaFunctionGauss(int _dim, const Point& center, double radius,int _exponent) : FWIDeltaKernel(_dim,center,radius,nullptr,_exponent) {
    Exit("dont use this plx");

    if (dim == 1) {
        normconst = 0.443993816168079;
    } else if (dim == 2) {
        switch (exponent) {
            case 1:
                normconst = 0.466512050417577;
                break;
            case 2:
                normconst = 0.117917361026638;
            break;
        default:
            Exit("wrong exponent")
        }
    } else if (dim == 3) {
        Exit("dimension 3 not implemnted in measurekernel");
    } else {
        Exit("no dimension specified... dim value: " + std::to_string(dim));
    }
}
double FWIDeltaFunctionGauss::operator() (const Point& x,const Cell&) const {
    double delta = dist(x,c);
    if (delta >= r) return 0;
    delta /= r;
    if (dim == 1){
        return centeredAndNormalizedValue(delta) * (1.0/(r));
    }
    if (dim == 2){
        return centeredAndNormalizedValue(delta) * (1.0/(r*r));
    }else {
        Exit("dimension not implemented");
    }
    return 0.0;
}






