//
// Created by cr on 11.11.22.
//

#ifndef FWI_FWIOBSERVATIONCREATOR_HPP
#define FWI_FWIOBSERVATIONCREATOR_HPP

#include "FWIObservationDGTSNEW.hpp"
#include "Observation/FWIObservationSpecification.hpp"

class FWIObservationCreator {
protected:
    const EleCacheType &eleCache;
    const Mesh &mesh;
    std::shared_ptr<FWIObservationSpecification> spec = nullptr;
    std::unique_ptr<MeasureMask> Mask = nullptr;
    std::unique_ptr<FWIObservationOperatorSpace> spaceOp = nullptr;
    std::unique_ptr<FWIObservationOperatorTime> timeOp = nullptr;
    int numL = -1;
    std::string obsSpec;
    int MeasureComp = 0;

    void getSpec();

    void readConfig();

public:

    explicit FWIObservationCreator(const EleCacheType &eleCache_, const Mesh &mesh_, int numL_);

    FWIObservationCreator &WithTimeOp(std::unique_ptr<FWIObservationOperatorTime> timeOp_);

    FWIObservationCreator &WithSpaceOp(std::unique_ptr<FWIObservationOperatorSpace> spaceOp_);

    FWIObservationCreator &WithMask(std::unique_ptr<MeasureMask> Mask_);

    FWIObservationCreator &WithSpec(std::shared_ptr<FWIObservationSpecification> spec_);

    FWIObservationOperatorNEW *Create();

    auto CreateShared() -> std::shared_ptr<FWIObservationOperatorNEW>;

    auto CreateUnique() -> std::unique_ptr<FWIObservationOperatorNEW>;
};


#endif //FWI_FWIOBSERVATIONCREATOR_HPP
