//
// Created by lionbart on 09.03.23.
//

#include "FWILinOpAdjRedSecondOrder.h"
//#include "normCalculator.hpp"


void FWILinOpAdjRedSecondOrder::CalculateAdjoint(const FWISeismogram &s, Vector &AdjointVector, Vectors *LambdaFull) {
    std::unique_ptr<Vector> LambdaStep;
    std::unique_ptr<Vector> zStep;
    std::unique_ptr<Vectors> zFull;
    LambdaStep = std::make_unique<Vector>(U_m[0]);
    zStep = std::make_unique<Vector>(U_m[0]);
    zFull = std::make_unique<Vectors>(U_m);
    LambdaStep->Clear();
    zStep->Clear();
    zFull->Clear();
    AdjointVector.Clear();//Is solution in the end

    Vectors lambda(U_m);//Sollte effizienter gehen!?
    if(LambdaFull == nullptr) {
        //Accumulation Flag should be fine now
        lambda = 0.0;
//        lambda.Clear();
//        lambda = 0.0;
        LambdaFull = &lambda;
        *LambdaFull = 0.0;
    }

    /*
     * Get \overline(u)_1 = \Phi'(Material)[MatDirection1]
     */
    std::shared_ptr<Vectors> u_prime;
    u_prime = std::make_shared<Vectors>(U_m);
    u_prime->Clear();
    LinOp->Solve(MatDirection, *u_prime);

    /*
     * Get Backwards solved solution lambda which solves
     * B lambda' - A^* lambda = g     , lambda(T) = 0
     * Time interval [0,T]; g is the Seismogram
     */
    //!!!Schnittstelle!!!
    AdjointRHS->setSeis(&s);
    assemble->ResetTime(TConf.t0, TConf.T, TConf.dt);
    timeIntegrator->Initialize(assemble.get(), *LambdaStep);//LambdaSTep hier richtig?!?! Sollte 0.0 sein.
    timeIntegrator->SetDivergenceCheck(false);
    mout.StartBlock("PhiAdjSO: ");
    mout << "Starting " << timeIntegrator->Name() << " (Order=" << timeIntegrator->GetOrder() << ")" << endl;

    //While-Schleife sollte erstmal nur lambdaFull berechnen. Von AdjFirstOrder übernommen.
//    int ii = 0;
//IN TestReducedSO2D gabs Fehler:
    // CORRUPTED DOUBLE LINKED LIST?!!? WO???
    // SIGABRT Fehler
    // Fehler ist weg häää???
    while (!assemble->IsFinished()) {
//        std::cout << "while Step startet" << std::endl;
        timeIntegrator->OneTimeStep(assemble.get(), *LambdaStep);
//        std::cout << "while Step In der Mitte angekommen" << std::endl;
        (*LambdaFull)[assemble->Step()] = *LambdaStep;
        //calculateL2AdjointStep(*LambdaStep2, AdjointVector, assemble->Step());    //Logic not (yet) necessary.
//        ii++;
//        std::cout << "while Step successfully Number: " << ii << std::endl;
    }//300 whiles
//    std::cout << "WhileSchleife LambdaFUll ist fertig. ZuTun: timeIntegrator noch destructen" << std::endl;

//    std::cout << ii << " DUmmy output stop hopping over everything you de Bugger" << std::endl;
    timeIntegrator->Destruct();

//    (*LambdaFull).reverse()
//    *LambdaFull *= -1.0;
    /*
     * zFull berechnen
     */
    std::shared_ptr<FWILinOpRedFirstOrder> LinOpBackward;
    LinOpBackward = std::make_shared<FWILinOpRedFirstOrder>(*LambdaFull, Material, LinOp->getProb(),
                                                            PMLH, TConf, eleCache,
                                                             false, true);
    //!!! Hier kommt aus NonlinSolveSO 2.InnereCG ... weiter unten ein not-accumulated error ://
    //!!! DGVAcousticRHSAssemblerLinearizedFirstOrder::RHS  --->>> b = (*A) * U_m[step + 1] + (*B) * U_m[step];
    LinOpBackward->Solve(MatDirection, *zFull);
    //Achtung: Lambda ist rückwärts gespeichert.
    //zFull ist auch rückwärts gelöst!!! (zFull[0] = 0 - vgl Endwertbedingung zFull(vorwärts)[T] = 0)


//    MOUT(nc::L2TNorm(*LambdaFull, eleCache, TConf.dt));
//    MOUT(nc::L2TNorm(*zFull, eleCache, TConf.dt));
    //26.03.2023 nach Versuch mit zFull berechnung fwd bwd fix
//    1.Test: Lambda 149.49094 *zFull 23.001354
//    2.Test: Lambda 149.49094 *zFull 50.589878

/* Größere Testausgabe */
    std::vector<int> checkWaveTimestep{0, 1, 2, 50, 51, 52, 53};
    std::vector<int> checkOutput{0,1, 2, 3, 4, 5, 6, 7, 8, 9, 30,31,32,33,34,35,100,101,102};
    verboseAdj = false;
    int iteration = 0;
    for(int timestep : checkWaveTimestep) {
        for (const auto& elemIt : eleCache) {// 512 Elements
            const DGAcousticElement &elem = *elemIt.second;
            const Cell &C = elem.GetCell();
            int Row = U_m[timestep].find_row(C()).Id();

            for (int j: checkOutput) {
                if (j == iteration && verboseAdj == true) {
                    mout << std::endl << "Timestep and Cell-Iteration: " << timestep << " and " << iteration << std::endl;
                }
            }
            for (int q = 0; q < elem.nQ(); ++q) {
                double w = elem.QWeight(q);
                const VectorField &v_um = elem.Velocity(q, U_m[timestep]);
                const VectorField &v_prime = elem.Velocity(q, (*u_prime)[timestep]);
                const VectorField &v_lamb = elem.Velocity(q, (*LambdaFull)[timestep]);
                double p_um = elem.Pressure_i(q, U_m[timestep], 0);
                double p_prime = elem.Pressure_i(q, (*u_prime)[timestep], 0);
                double p_lamb = elem.Pressure_i(q, (*LambdaFull)[timestep], 0);

                for (int j: checkOutput) {
                    if (j == iteration && verboseAdj == true) {
                        mout << "Weight q: " << q << endl;
                        mout << "VectorField U_m, u_prime, lambda " << v_um << ",  " << v_prime << ",  " << v_lamb
                             << endl;
                        mout << "pressure U_m, u_prime, lambda   " << p_um << ",  " << p_prime << ",  " << p_lamb
                             << endl;
                    }
                }
                iteration++;
            }
        }
//        std::cout << "Total iterations: " << iteration << std::endl;//1024 (test SO Adj)
        iteration = 0;
    }//Größere Testausgabe Ende

    /*
     * Calculate the Integral
     */
    assemble->ResetTime(TConf.t0, TConf.T, TConf.dt);
    while (!assemble->IsFinished()) {
//        timeIntegrator->OneTimeStep(assemble.get(), *LambdaStep2);
        assemble->NextTimeStep();//Taken from timeIntegrator method. Otherwise infinity while loop
        calculateL2AdjointStep(*LambdaFull, *zFull,
                                *u_prime, AdjointVector, assemble->Step());
    }
    mout.EndBlock();
    AdjointVector *= -1.0; //Passt zur Umsetzung hier, die um ein Minus von Formeln abweicht.
}

/*
 * Prepares the Integral-step calculation
 * Will be calculated backwards (since zFull, LambdaFull are backwards solved)
 */
//Alle rückwärts gelösten Felder ..[step], Vorwärtsfelder ..[StepBwd]
void FWILinOpAdjRedSecondOrder::calculateL2AdjointStep(const Vectors &LambdaFull, const Vectors &zFull,
                                                       Vectors &U_prime, Vector &AdjointVector, int step) {
    //Erster Step ist step=1
    int StepBwd = (U_m).size() - 1 - step;

    Vector U_m_fd(U_m[StepBwd + 1]);
    Vector U_prime_fd(U_prime[StepBwd + 1]);
//    U_m_fd.Clear();U_prime_fd.Clear();

//    U_m_fd = U_m[StepBwd + 1];
    U_m_fd -= U_m[StepBwd];
    U_m_fd *= (1.0 / TConf.dt);

//    U_prime_fd = U_prime[StepBwd + 1];
    U_prime_fd -= U_prime[StepBwd];
    U_prime_fd *= (1.0 / TConf.dt);

    //Inputs to OneStep method are only Vector types, not Vectors.
    fwiAdjointCalculator->calculateL2AdjointOneStepSO(U_m_fd, U_prime_fd, LambdaFull[step],
                                                      zFull[step], MatDirection, AdjointVector, Psi);
}

FWILinOpAdjRedSecondOrder::FWILinOpAdjRedSecondOrder(const Vectors &U_m_, const Vector &MatVec_, const Vector &MatDirection_,
                                                     const FWIObservationOperatorNEW &Obs,
                               const std::shared_ptr<WaveProblemDGTSVA> &prob_, const std::shared_ptr<PMLHandler> &PMLH_,
                               const TimeConf &TConf_, const reconstructionContainer &recon,
                               const EleCacheType &eleCache_, const bool Psi_) : PMLH(PMLH_), eleCache(eleCache_), U_m(U_m_),
                                                                Material(MatVec_), MatDirection(MatDirection_),
                                                                TConf(TConf_), Psi(Psi_) {
    AdjointRHS = std::make_shared<DGVAcousticRHSAssemblerAdjoint>(Obs);
    VAPlotter = std::make_shared<DGVAcousticPlotter>(prob_->getNumL(), nullptr);
    auto Mat = std::make_unique<FWIDGVAcousticMaterialFromVector>(*prob_, Material, PMLH.get());
    /*
     * Nutzung für Schleife, wo Lambda (Rückwärtsproblem gelöst wird)
     * Dann in Schleife wo calculateL2AdjointStep berechnet wird, wirds als Zeitstepper benutzt.
     */
    matrixAssembler = std::make_shared<DGVAcousticMatrixAssembler>(std::move(Mat), false);
    assemble = std::make_shared<DGVAcousticAssembleCombined>(VAPlotter, matrixAssembler, AdjointRHS,
                                                             TConf.t0,TConf.T,TConf.dt);
    assemble->SetEleCache(&eleCache);

    fwiAdjointCalculator = std::make_unique<FWIAdjointCalculator>(Material, prob_->getParametrization(), eleCache,
                                                                  recon, prob_->getNumL(), TConf.dt, prob_);
    timeIntegrator = GetFWITI(TConf.rkorder);

    bool discrete = false; //Required Argument for First Order and I do not know what it changes...
    //LinOp might as well be given as a pointer in the arguments.
    LinOp = std::make_shared<FWILinOpRedFirstOrder>(U_m_, MatVec_, prob_, PMLH_, TConf_, eleCache_, discrete);

    //!! Kann der wirklich raus?
//    LinAssembler = std::make_unique<FWILinearizedAssembler>(prob_, eleCache_, MatVec_);
}

void FWILinOpAdjRedSecondOrder::calculateL2AdjointStep(const Vector &LambdaStep, Vector &AdjointVector, int step) {
    Exit("Not implemented here. Inheritance not fully used :/")
}
