//
// Created by cr on 18.11.22.
//

#ifndef FWI_FWILINOPREDFIRSTORDER_HPP
#define FWI_FWILINOPREDFIRSTORDER_HPP

#include "Vector.hpp"
#include "FWITimeSolver.hpp"
#include "DGVAcousticAssembleCombined.hpp"
#include "DGVAcousticMatrixAssembler.hpp"
#include "FWIDGVAcousticMaterialFromVector.hpp"
#include "Assembler/FWIRhsAssemblerLinearized.hpp"
#include "FWILinOpRed.hpp"

class FWILinOpRedFirstOrder : public FWILinOpRed {

    const std::shared_ptr<WaveProblemDGTSVA> &prob;
    const Vectors &U_m;
    const Vector &m;
    const std::shared_ptr<PMLHandler> &PMLH;
    std::shared_ptr<DGVAcousticMatrixAssembler> matrixAssembler = nullptr;
    std::shared_ptr<DGVAcousticPlotter> VAPlotter;
    const EleCacheType &eleCache;
    const TimeConf &TConf;
    bool discrete = false;
    bool bwd = false;
protected:
    std::shared_ptr<DGVAcousticAssembleCombined> getAssembler(const Vector &m_test);

public:
    FWILinOpRedFirstOrder(const Vectors &U_m_, const Vector &m_, const std::shared_ptr<WaveProblemDGTSVA> &prob_,
                          const std::shared_ptr<PMLHandler> &PMLH_, const TimeConf &TConf_, const EleCacheType &eleCache_,
                          bool discrete, bool bwd_ = false);

    void Solve(const Vector &m_test, Vectors &U_linearized) override;

    void SolveAndMeasure(const Vector &m_test, const FWIObservationOperatorNEW &Obs,
                         FWISeismogram &s_linearized, Vectors *U_linearized) override;

    const Vectors &getUM() const;

    const std::shared_ptr<WaveProblemDGTSVA> &getProb() const;

    const Vector &getM() const;

    const std::shared_ptr<PMLHandler> &getPmlh() const;

    bool isDiscrete() const;

    const std::shared_ptr<DGVAcousticMatrixAssembler> &getMatrixAssembler() const;

    const std::shared_ptr<DGVAcousticPlotter> &getVaPlotter() const;

    const EleCacheType &getEleCache() const;

    const TimeConf &getTConf() const;

};


#endif //FWI_FWILINOPREDFIRSTORDER_HPP
