//
// Created by cr on 24/03/23.
//

#ifndef FWI_FWILINOPREDFIRSTORDERNORMALIZED_HPP
#define FWI_FWILINOPREDFIRSTORDERNORMALIZED_HPP

#include "FWITimeSolver.hpp"
#include "NormalizedHelpers.hpp"
#include "FWILinOpRedFirstOrder.hpp"

class FWILinOpRedFirstOrderNormalized : public FWILinOpRedFirstOrder {
  const FWISeismogram &sMNormed;
  const std::unordered_map<Point,double> &sMNorms;
public:
  FWILinOpRedFirstOrderNormalized(const Vectors &U_m_, const FWISeismogram& sMNormed_,
                        const std::unordered_map<Point,double> &sMNorms_, const Vector &m_,
                        const std::shared_ptr<WaveProblemDGTSVA> &prob_,
                        const std::shared_ptr<PMLHandler> &PMLH_, const TimeConf &TConf_,
                        const EleCacheType &eleCache_,bool discrete)
      : FWILinOpRedFirstOrder(U_m_,m_,prob_,PMLH_,TConf_,eleCache_,discrete),
        sMNormed(sMNormed_), sMNorms(sMNorms_)
  {}

  void Solve(const Vector &m_test, Vectors &U_linearized){ Exit("Makes no sense here")}

  void SolveAndMeasure(const Vector &m_test, const FWIObservationOperatorNEW &Obs,
                       FWISeismogram &s_linearized, Vectors *U_linearized){
    FWITimeSolver TSolveR(getUM()[0], getPmlh(), getTConf().rkorder);
    TSolveR.SolveAndMeasure(getAssembler(m_test), Obs, s_linearized, U_linearized);
    PrepareLinearizedAndAdjointNormalized(sMNormed,sMNorms,s_linearized);
  }
};

#endif //FWI_FWILINOPREDFIRSTORDERNORMALIZED_HPP
