//
// Created by cr on 15/03/23.
//

#ifndef FWI_NORMALIZEDHELPERS_HPP
#define FWI_NORMALIZEDHELPERS_HPP


static void TraceWiseScalarProductAndApply(const FWISeismogram &Seis1, const FWISeismogram &Seis2,
                                    FWISeismogram &Seis3) {
  std::unordered_map<Point,double> factors;
  TraceWiseScalarProduct(Seis1,Seis2,factors);
  MultiplyByFactorTracewise(Seis3,factors);
}

static void PrepareLinearizedAndAdjointNormalized(const FWISeismogram &SeisMNormed,
                                           const std::unordered_map<Point, double> &SeisMNorms,
                                           FWISeismogram &Seis) {
  DivideByFactorTracewise(Seis,SeisMNorms);
  FWISeismogram tmp(SeisMNormed);
  TraceWiseScalarProductAndApply(Seis,SeisMNormed,tmp);
  Seis -= tmp;
}





#endif //FWI_NORMALIZEDHELPERS_HPP
