//
// Created by cr on 17/01/23.
//

#include <fftw3.h>
#include <complex>
#include "SourceInversion.hpp"

//void SourceInversion(const FWISeismogram &obs, const FWISeismogram &fwd, SourceWaveletBase &src,
//                     double eps) {
//
//  CVector srcFFT = src.GetFFT();
//  CMatrix obsFFT = obs.GetFFT();
//  CMatrix fwdFFT = fwd.GetFFT();
//  std::complex<double> denom;
//  std::complex<double> num;
//  CVector kappa = src.GetFFT();
//  kappa = 0.0;
//  double energy = 0.0;
//  int nrTraces = fwdFFT.rows();
//  int nrFreq = fwdFFT.cols();
//  if (obs.getSpecification().nSteps() != src.GetEvalsOnGrid().size()) {
//    THROW("Size of vectors does not fit!")
//  }
//  for (int omega = 0; omega < nrFreq; ++omega) {
//    for (int trace = 0; trace < nrTraces; ++trace) {
//      energy += norm(fwdFFT[trace][omega]);
//    }
//  }
//  energy /= nrFreq;
//  for (int omega = 0; omega < nrFreq; ++omega) {
//    num.real(0);
//    num.imag(0);
//    denom.real(0);
//    denom.imag(0);
//    for (int trace = 0; trace < nrTraces; ++trace) {
//      num += nrTraces * conj(fwdFFT[trace][omega]) * obsFFT[trace][omega];
//      denom += nrTraces * norm(fwdFFT[trace][omega]);
//    }
//    kappa[omega] = num / (denom + eps * eps * energy);
//  }
//  srcFFT *= kappa;
//  RVector srcNEW(0.0, src.GetEvalsOnGrid().size());
//  FFT::InvComplexToRealVector(srcFFT, srcNEW);
//  src.SetEvalsOnGrid(srcNEW);
//}
//fftw_complex conjprod(fftw_complex a,fftw_complex b){
//  fftw_complex ret;
//  ret[0] = a[0]*b[0] + a[1] * b[1];
//  ret[1] = a[1]*b[0]-a[0]*b[1];
//  return ret;
//}
//fftw_complex operator * (fftw_complex &x,fftw_complex &y){
//
//}
void writeToBin(char* fn,std::vector<float> &data) {
  auto fpdata = fopen(fn, "w");
  for (int j = 0; j < data.size(); j++) {
    fwrite(&data[j], sizeof(float), 1, fpdata);
  }
}
void SourceInversion(const FWISeismogram &obs, const FWISeismogram &fwd, const Point &srcPos, SourceWaveletBase &src,
                     const FWIObservationOperatorSpace * SpOp, double eps, double kappa) {
  int ns = fwd.getSpecification().nSteps();
  int Npad = (int) (pow(2.0,
                        ceil(logf((float) (fwd.getSpecification().nSteps())) / log(2.0)) + 0.0));
  std::vector<std::complex<double>> sumn(Npad,0.0),sumd(Npad,0.0), D_s(Npad,0.0), D_ss(Npad,0.0);
  std::vector<std::complex<double>> D_s2(Npad,0.0), D_ss_fd(Npad,0.0), D_s_td(Npad,0.0);
  auto &wavelet =  src.GetEvalsOnGrid();
  for (int j = 0; j < Npad; j++) {
    if (j < ns-1) {
      D_ss[j].real(wavelet[j+1]);
      D_ss[j].imag(0.0);
    } else {
      D_ss[j].imag(0.0);
      D_ss[j].real(0.0);
    }
  }
  fftw_plan p_s;
  for (int j = 0; j < Npad; j++) {
    D_ss_fd[j].real(0.);
    D_ss_fd[j].imag(0.);
  }
  p_s = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(D_ss.data()),
                         reinterpret_cast<fftw_complex *>(D_ss_fd.data()), 1, FFTW_ESTIMATE);
  fftw_execute(p_s);

//  char qw1[100];
//  char qw2[100];
//  std::vector<float> D_ss_print_real(Npad,0.0),D_ss_print_imag(Npad,0.0);
//  std::vector<float> D_ss_fd_print_real(Npad,0.0),D_ss_fd_print_imag(Npad,0.0);
//  for (int  j = 0; j< Npad;++j){
//    D_ss_print_real[j] = (float) (D_ss[j].real());
//    D_ss_fd_print_real[j] = (float) (D_ss_fd[j].real());
//    D_ss_print_imag[j] = (float) D_ss[j].imag();
//    D_ss_fd_print_imag[j] = (float) (D_ss_fd[j].imag());
//  }
//  sprintf(qw1,"FWI.D_ss_real");
//  sprintf(qw2,"FWI.D_ss_imag");
//  writeToBin(qw1,D_ss_print_real);
//  writeToBin(qw2,D_ss_print_imag);
//  sprintf(qw1,"FWI.D_ss_fd_real");
//  sprintf(qw2,"FWI.D_ss_fd_imag");
//  writeToBin(qw1,D_ss_fd_print_real);
//  writeToBin(qw2,D_ss_fd_print_imag);
  double Ebar = 0.0;
  int ntr_glob = fwd.getSpecification().size();
  auto receiversSorted = fwd.getSpecification();
  receiversSorted.sort();
  int i =0;
  for (const auto& rec : receiversSorted ) {
    std::vector<std::complex<double>> in_dat(Npad,0.0),out_dat(Npad,0.0),in_model(Npad,0.0),out_model(Npad,0.0);
    if(SpOp) {
      if (!SpOp->MeasureHere(rec)) continue;
    }
//    double f_k = pow(dist(srcPos, rec), kappa);
    auto &tsFwd = fwd.getTimeSeries(rec);
    auto &tsObs = obs.getTimeSeries(rec);
    fftw_plan p_dat, p_model;
    for (int j = 0; j < Npad; j++) {
      if (j < ns-1) {
        in_model[j].real((*tsFwd[j+1].second)[0]);
        in_model[j].imag(0.0);
        in_dat[j].real((*tsObs[j+1].second)[0]);
        in_dat[j].imag(0);
      } else {
        in_model[j].real(0);
        in_model[j].imag(0);
        in_dat[j].real(0);
        in_dat[j].imag(0);
      }
    }
    p_dat = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(in_dat.data()),
                             reinterpret_cast<fftw_complex *>(out_dat.data()), 1, FFTW_ESTIMATE);
    p_model = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(in_model.data()),
                               reinterpret_cast<fftw_complex *>(out_model.data()), 1, FFTW_ESTIMATE);
    fftw_execute(p_dat);
    fftw_execute(p_model);
//    std::vector<float> in_dat_print_real(Npad,0.0),in_dat_print_imag(Npad,0.0);
//    std::vector<float> out_dat_print_real(Npad,0.0),out_dat_print_imag(Npad,0.0);
//    std::vector<float> in_model_print_real(Npad,0.0),in_model_print_imag(Npad,0.0);
//    std::vector<float> out_model_print_real(Npad,0.0),out_model_print_imag(Npad,0.0);
//    for (int  j = 0; j< Npad;++j){
//      in_dat_print_real[j] = (float) (in_dat[j].real());
//      in_dat_print_imag[j] = (float) in_dat[j].imag();
//      out_dat_print_real[j] = (float) out_dat[j].real();
//      out_dat_print_imag[j] = (float) out_dat[j].imag();
//      in_model_print_real[j] = (float) in_model[j].real();
//      in_model_print_imag[j] = (float) in_model[j].imag();
//      out_model_print_real[j] = (float) out_model[j].real();
//      out_model_print_imag[j] = (float) out_model[j].imag();
//    }
//    int STRINGSIZE=100;
//    char qw3[STRINGSIZE];
//    char qw4[STRINGSIZE];
//    char qw6[STRINGSIZE];
//    char qw5[STRINGSIZE];
//    sprintf(qw3,"FWI.in_dat_print_real.shot%d.su",i);
//    sprintf(qw4,"FWI.in_dat_print_imag.shot%d.su",i);
//    sprintf(qw5,"FWI.out_dat_print_real.shot%d.su",i);
//    sprintf(qw6,"FWI.out_dat_print_imag.shot%d.su",i);
//    writeToBin(qw3,in_dat_print_real);
//    writeToBin(qw4,in_dat_print_imag);
//    writeToBin(qw5,out_dat_print_real);
//    writeToBin(qw6,out_dat_print_imag);
//    sprintf(qw3,"FWI.in_model_print_real.shot%d.su",i);
//    sprintf(qw4,"FWI.in_model_print_imag.shot%d.su",i);
//    sprintf(qw5,"FWI.out_model_print_real.shot%d.su",i);
//    sprintf(qw6,"FWI.out_model_print_imag.shot%d.su",i);
//    writeToBin(qw3,in_model_print_real);
//    writeToBin(qw4,in_model_print_imag);
//    writeToBin(qw5,out_model_print_real);
//    writeToBin(qw6,out_model_print_imag);
    for (int j = 0; j < Npad; j++) {
      sumn[j] +=  ntr_glob * out_dat[j] * conj(out_model[j]);
      sumd[j] +=  ntr_glob * out_model[j] * conj(out_model[j]);
      Ebar += sumd[j].real();
    }
    fftw_destroy_plan(p_dat);
    fftw_destroy_plan(p_model);
    ++i;
  }
//  int STRINGSIZE=100;
//  char qw3[STRINGSIZE];
//  char qw4[STRINGSIZE];
//  std::vector<float> sumn_print_real(Npad,0.0),sumn_print_imag(Npad,0.0);
//    std::vector<float> sumd_print_real(Npad,0.0),sumd_print_imag(Npad,0.0);
//  for (int  j = 0; j< Npad;++j){
//    sumn_print_real[j] = (float) (sumn[j].real());
//    sumn_print_imag[j] = (float) sumn[j].imag();
//    sumd_print_real[j] = (float) sumd[j].real();
//    sumd_print_imag[j] = (float) sumd[j].imag();
//  }
//  sprintf(qw3,"FWI.sumn_real");
//  sprintf(qw4,"FWI.sumd_real");
//  writeToBin(qw3,sumn_print_real);
//  writeToBin(qw4,sumd_print_real);
//  sprintf(qw3,"FWI.sumn_imag");
//  sprintf(qw4,"FWI.sumd_imag");
//  writeToBin(qw3,sumn_print_imag);
//  writeToBin(qw4,sumd_print_imag);
  PPM->Sum(sumn);
  PPM->Sum(sumd);

  Ebar = Ebar / Npad;
//  std::vector<float> D_s_print_real(Npad,0.0),D_s_print_imag(Npad,0.0);
  for (int j = 0; j < Npad; j++) {
    D_s[j] = sumn[j]/(sumd[j].real() + eps * eps* Ebar);
  }
//  for (int  j = 0; j< Npad;++j){
//    D_s_print_real[j] = (float) (D_s[j].real());
//    D_s_print_imag[j] = (float) D_s[j].imag();
//  }
//  sprintf(qw3,"FWI.D_s_real");
//  sprintf(qw4,"FWI.D_s_imag");
//  writeToBin(qw3,D_s_print_real);
//  writeToBin(qw4,D_s_print_imag);
  fftw_plan p_cf;
  p_cf = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(D_s.data()),
                          reinterpret_cast<fftw_complex *>(D_s_td.data()), -1, FFTW_ESTIMATE);
  fftw_execute(p_cf);
  for (int j = ns; j < Npad; j++) {
    D_s_td[j].real(0.0);
    D_s_td[j].imag(0.0);
  }
  fftw_plan p_cf2;
  p_cf2 = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(D_s_td.data()),
                          reinterpret_cast<fftw_complex *>(D_s.data()), 1, FFTW_ESTIMATE);
  fftw_execute(p_cf2);
  for (int j = 0; j < Npad; j++) {
    D_s[j] = D_ss_fd[j] * D_s[j]* 1.0/Npad;
  }
//  for (int  j = 0; j< Npad;++j){
//    D_s_print_real[j] = (float) (D_s[j].real());
//    D_s_print_imag[j] = (float) D_s[j].imag();
//  }
//  sprintf(qw3,"FWI.D_s_real_2");
//  sprintf(qw4,"FWI.D_s_imag_2");
  fftw_destroy_plan(p_cf);
  fftw_destroy_plan(p_cf2);
  fftw_plan p_stf;
  p_stf = fftw_plan_dft_1d(Npad, reinterpret_cast<fftw_complex *>(D_s.data()),
                           reinterpret_cast<fftw_complex *>(D_s_td.data()), -1, FFTW_ESTIMATE);
  fftw_execute(p_stf);
  RVector waveletTmp(wavelet);
  waveletTmp = 0.0;
  for (int j = 0; j < wavelet.size()-1;++j){
    waveletTmp[j+1] = D_s_td[j].real()*1.0/Npad;;
  }
  fftw_destroy_plan(p_stf);
  fftw_destroy_plan(p_s);
  src.SetEvalsOnGrid(waveletTmp);
}