//
// Created by cr on 14.10.21.
//

#include "VectorsIntegrator.hpp"

void VectorsIntegrator::integrateOneStep() const {
  for (size_t stage = 0; stage < c.size(); ++stage) {
    integratedVec += b[stage] * dt
                     * WaveFieldPoint[step - 1 + static_cast<int>(rint(c[stage]))];
  }
  step++;
}

VectorsIntegrator::VectorsIntegrator(const Vectors &WaveFieldPoint_, double dt_, int rkorder_) :
    WaveFieldPoint(WaveFieldPoint_), integratedVec(WaveFieldPoint_[0]), rkorder(rkorder_),
    dt(dt_) {
  fillQuadrature(c, b, rkorder);
    integratedVec = 0;
  if (rkorder_ == 1) {Exit("fix this"); }
  if (rkorder_ == -2) {Exit("dont use this with rkorder -2"); }
}

VectorsIntegrator::VectorsIntegrator(const Vectors &WaveFieldPoint_) :
    WaveFieldPoint(WaveFieldPoint_), integratedVec(WaveFieldPoint_[0]) {
    Config::Get("rkorder", rkorder);
    Config::Get("dt", dt);
    fillQuadrature(c, b, rkorder);
    integratedVec = 0;
    if (rkorder == 1) {Exit("fix this"); }
    if (rkorder == -2) {Exit("dont use this with rkorder -2"); }
}

const Vector &VectorsIntegrator::GetIntegratedVec() const {
  return integratedVec;
}

const Vector &VectorsIntegrator::integrateOneStepAndGetVector() const {
  if (step == 0) {
    step++;
    return GetIntegratedVec();
  } else {
    integrateOneStep();
    return GetIntegratedVec();
  }
}
