//
// Created by cr on 14.10.21.
//

#ifndef FWI_VECTORSINTEGRATOR_HPP
#define FWI_VECTORSINTEGRATOR_HPP


#include <RVector.hpp>
#include <Vector.hpp>
#include "FWIHelpers.hpp"

class VectorsIntegrator {
  void integrateOneStep() const;

  RVector c;
  RVector b;
  mutable Vector integratedVec;
  mutable int step = 0;
  int rkorder;
  double dt;
public:
    const Vectors &WaveFieldPoint;

    VectorsIntegrator(const Vectors &WaveFieldPoint_, double dt_, int rkorder_);

    VectorsIntegrator(const Vectors &WaveFieldPoint_);

    const Vector &GetIntegratedVec() const;

    const Vector &integrateOneStepAndGetVector() const;

    void Reset() const {
        integratedVec.Clear();
        step = 0;
    }
};


#endif //FWI_VECTORSINTEGRATOR_HPP
