//
// Created by cr on 14.07.22.
//

#include "FWITestAllAtOnce2D.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<std::vector<double>> FWIInverseMainDGTSVA();

class FWITestAllAtOnce2D : public Test {
public:
    FWITestAllAtOnce2D() {
        Config::Initialize(TestFWIAllAtOnce2DConfigMap);
    }

    void TearDown() override {
        Config::Close();
    }
};

TEST_F(FWITestAllAtOnce2D, TestFWIInverseMainDGTSVA) {
    std::vector<double> output = FWIInverseMainDGTSVA()[1];
    std::vector<double> input;
    input = {401.86331754249,
             46.5178078944036,
             37.5603197492563};
    mout << output << endl;
    for (int i = 0; i < input.size(); i++) {
        input[i] -= output[i];
        input[i] *= 1.0 / output[i];
    }
    EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
    return MppTest(
            MppTestBuilder(argc, argv).
                    WithoutDefaultConfig().
                    WithScreenLogging().
                    WithConfPath("../").
                    WithGeoPath("../conf/geo/").
                    WithPlotPath("data/vtu/").
                    WithPPM()
    ).RUN_ALL_MPP_TESTS();
}
