//
// Created by cr on 14.07.21.
//

#include "FWITestReduced2D.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<std::vector<double>> FWIInverseMainDGTSVA();

class FWITestReduced2D : public Test {
public:
    FWITestReduced2D() {
        Config::Initialize(TestFWIReduced2DConfigMap2);
    }

    void TearDown() override {
        Config::Close();
    }
};

TEST_F(FWITestReduced2D, TestFWIInverseMainDGTSVA) {
    std::vector<double> output = FWIInverseMainDGTSVA()[1];
    std::vector<double> input;
    input = {0.232664034663109,
0.159569173745128,
0.0822061597164788};
    std::cout << endl;
    for (int i = 0; i < input.size(); i++) {
        std::cout << output[i] << endl;

        input[i] -= output[i];
        input[i] *= 1.0 / output[i];
    }
    EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
    return MppTest(
            MppTestBuilder(argc, argv).
                    WithoutDefaultConfig().
                    WithScreenLogging().
                    WithConfPath("../").
                    WithGeoPath("../conf/geo/").
                    WithPlotPath("data/vtu/").
                    WithPPM()
    ).RUN_ALL_MPP_TESTS();
}
