//
// Created by cr on 24/03/23.
//

#ifndef FWI_FWITESTREDUCEDSO2D_HPP
#define FWI_FWITESTREDUCEDSO2D_HPP
#include <string>
#include <map>

using ConfigMap = std::map<std::string, std::string>;
const ConfigMap TestFWIReducedSO2DConfigMap{
    {"ConfigVerbose",                  "0"},
    {"ForwardSolver",                  " VADGTS"},
    {"Distribution",                   " RCB"},
    {"Model",                          " FWIInverse_DGTS"},
    {"Mesh",                           " SeismogramGrid_test"},
    {"Problem",                        " VAcousticWaveC2Benchmark"},
//        {"Problem",                        "ADDAX"},
    {"useTaper",                       "1"},
    {"taperRadiusSource",              "0"},
    {"taperRadiusReceiver",            "0"},
    {"taperExponent",                  "-0.1"},
    {"taperIgnoreReceiverCells",       "1"},
    {"taperIgnoreSourceCells",         "1"},
    {"Monoparam",                      " "},
    {"ReconstructionType",             "SO"},
    {"FWIReceiverWaypoints",           " 2"},
    {"FWIReceiverWaypoint0",           " 1350.0, 370.0"},
    {"FWIReceiverWaypoint1",           " 1350.0, 1630.0"},
    {"FWIReceiverIncludeLastWaypoint", " 1"},
    {"FWIReceiverCount0",              " 32"},
    {"UseSparseMatrix",                "1"},
    {"Qfactor",                        "100"},
    {"SignalName",                     "RickerDerivative"},
    {"SignalDelay",                    "0"},
    {"SignalCutoff",                   "0.8"},
    {"SignalFreq",                     "25"},
    {"numL",                           "0"},
    {"FWISourceWaypoints",             "2"},
    {"FWISourceWaypoint0",             "600,370"},
    {"FWISourceWaypoint1",             "600,1620"},
    {"FWISourceCount0",                "2"},
    {"FWIReceiverIncludeLastWaypoint", "1"},
    {"measurement_space",              " point"},
    {"measurement_time",               " point"},
    {"compMeasure",                    " 0"},
    {"source_component",               " 2"},
    {"perturbation_comp",              " 2"},
    {"dampingFlux",                    " 1"},
    {"allowPlotting_M",                "1"},
    {"allowPlotting_WF",               "0"},
    {"plotfactor",                     " 10"},
    {"parametrization",                " taup"},//changed to taup
    {"T",                              "0.6"},
    {"dt",                             " 0.002"},
    {"deg",                            " 1"},
    {"level ",                         " 0"},
    {"TimeVerbose",                    " 1"},
    {"plot_tStep",                     " -1"},
    {"rkorder",                        " -2"},

    {"Kmax",                           "150"},
    {"Keps",                           " 1e-07"},
    {"Overlap",                        " dG1"},
    {"debugAdjoint",                   " 0"},
    {"debugFrechet",                   " 1"},
    {"source_factor",                  " 242574257420000.5742"},
    {"LinearSolver",                   " LS"},
    {"LinearVerbose",                  " -1"},
    {"LinearSteps",                    "100"},
    {"LinearNthIterOutput",    " 1"},
    {"LinearEpsilon",          " 1e-12"},
    {"LinearReduction",        " 0.0001"},
    {"FWINonlinearSolver",     " FWISO"},
    {"FWI_DebugPlottingLevel", " 1"},
    {"FWIReconstructRho",      " 1"},
    {"FWIReconstructV_P",      " 1"},
    {"FWIReconstructTauP",     " 1"},
    {"CGREGINNCanonic_Steps",  "3"},
};

// Regular Expression, RegExpr um aus Test_Config von Clion eine ... M++ Config zu machen
// \{"([A-Za-z0-9_ ]+)", +"([A-Za-z0-9_ ,\.\-]+)"}.

#endif //FWI_FWITESTREDUCEDSO2D_HPP
