//
// Created by cr on 13/02/23.
//

#include "FWITestSTF.hpp"
#include "TestEnvironment.hpp"

#include "ForwardModels/FWIForwardModelDGTSVA.hpp"
#include "Problems/Sources/FWISourceWavelet.hpp"


class FWTTestSTF : public Test {
public:
  FWTTestSTF() {
    Config::Initialize(FWTTestSTFConfigMap);
  }

  void TearDown() override {
    Config::Close();
  }
};

TEST_F(FWTTestSTF, TestFWIInverseMainDGTSVA) {
SourceFromFile stf0("InvSourcetime_iter_0shot_0");
SourceFromFile stf1("InvSourcetime_iter_0shot_1");
SourceFromFile stf2("InvSourcetime_iter_0shot_2");
std::vector<RVector> RVECS;
RVECS.push_back(stf0.GetEvalsOnGrid());
RVECS.push_back(stf1.GetEvalsOnGrid());
RVECS.push_back(stf2.GetEvalsOnGrid());
SourceFromFile stfCalc0(Config::GetDataPath() + "InvSourcetime_iter_0shot_0");
SourceFromFile stfCalc1(Config::GetDataPath() + "InvSourcetime_iter_0shot_1");
SourceFromFile stfCalc2(Config::GetDataPath() + "InvSourcetime_iter_0shot_2");
  std::vector<RVector> RVECS2;
RVECS2.push_back(stfCalc0.GetEvalsOnGrid());
RVECS2.push_back(stfCalc1.GetEvalsOnGrid());
RVECS2.push_back(stfCalc2.GetEvalsOnGrid());
vector<double> diffs;
for (int i = 0; i <RVECS.size();++i){
  RVECS2[i]-=RVECS[i];
  diffs.push_back(RVECS2[i].norm());
}
  EXPECT_VECTOR_NEAR(diffs, std::vector<double>(diffs.size(), 0.0), 1e-14);


}

int main(int argc, char **argv) {
  return MppTest(
      MppTestBuilder(argc, argv).
          WithoutDefaultConfig().
          WithScreenLogging().
          WithConfPath("../").
          WithGeoPath("../conf/geo/").
          WithPlotPath("data/vtu/").
          WithPPM()
  ).RUN_ALL_MPP_TESTS();
}