//
// Created by lionbart on 13.02.23.
//

#ifndef FWI_FWITESTSECONDDERIVATIVE_H
#define FWI_FWITESTSECONDDERIVATIVE_H

#include <string>
#include <map>
//Config taken from TestLinearized
using ConfigMap = std::map<std::string, std::string>;
const ConfigMap TestFWISecondDerivative{
        {"ConfigVerbose",                  "2"},
        {"ForwardSolver",                  "VADGTS"},
        {"Distribution",                   "RCB"},
        {"Model",                          "FWIInverse_DGTS"},
        {"CountCellsOld",                  "0"},
        {"dim",                            "1"},
        {"taup_bg",                        "0.1"},
        {"Mesh",                           "oneDim"},
        {"Problem",                        "Benchmark1D"},
        {"startingValue_",                 "1"},
        {"Preconditioner_S",               "SuperLU"},
        {"Preconditioner_M",               "PointBlockJacobi"},
        {"Problem",                        "VAcousticWaveC2Benchmark"},
        {"ReconstructionType",             "Classical"},
        {"sourceSpace",                    "2"},
        {"useTaper",                       "0"},
        {"taperRadiusSource",              "0"},
        {"taperRadiusReceiver",            "100"},
        {"taperExponent",                  "-0.1"},
        {"taperIgnoreReceiverCells",       "1"},
        {"taperIgnoreSourceCells",         "0"},
        {"Monoparam",                      "Vp"},
        {"SignalName",                     "Ricker"},
        {"SignalFreq",                     "10"},
        {"SignalCutoff",                   "0"},
        {"SignalDelay",                    "0"},
        {"numberOfSourcesPerShot",         "1"},
        {"rho_bg",                         "2"  },
        {"v_bg",                           "5.0"},
        {"size_perturb",                   "0"},
        {"FWIReceiverWaypoints",           "2"},
        {"FWIReceiverWaypoint0",           "2.1 0"},
        {"FWIReceiverWaypoint1",           "3.5 0"},
        {"FWIReceiverIncludeLastWaypoint", "0"},
        {"FWIReceiverCount0",              "20"},
        {"UseSparseMatrix",                "1"},
        {"f_source",                       "10"},
        {"FWISourceWaypoints",             "2"},
        {"FWISourceWaypoint0",             "0.5, 0"},
        {"FWISourceWaypoint1",             "0.5, 0"},
        {"FWISourceCount0",                "1"},
        {"FWISourceIncludeLastWaypoint",   "0"},
        {"numL",                           "0"},//changed from 2 to 0.
        {"compMeasure",                    "0"},
        {"source_component",               "2"},
        {"allowPlotting_M",                "1"},
        {"allowPlotting_WF",               "1"},
        {"plotFactor",                     "1"},
        {"parametrization",                "taup"},//changed to taup from taup_positive
        {"T",                              "1.00"},
        {"dt",                             "0.005"},
        {"deg",                            "1"},
        {"level",                          "8"},
        {"plot_tStep",                     "-1"},
        {"rkorder",                        "-2"},
        {"Overlap",                        "dG1"},
        {"LinearSolver",                   "LS"},
        {"LinearVerbose",                  "-1"},
        {"FWIReconstructRho",              "0"},
        {"FWIReconstructV_P",              "1"},
        {"plotV",                          "1"}
};
//Old one, didnt work. Dont know where I took it from in the first place. Probably from secondOrderMaterial Test
//using ConfigMap = std::map<std::string, std::string>;
//const ConfigMap TestFWISecondDerivative{
//        {"ConfigVerbose",                  "2"},
//        {"ForwardSolver",                  "VADGTS"},
//        {"Distribution",                   "RCB"},
//        {"Model",                          "FWIInverse_DGTS"},
//        {"CountCellsOld",                  "0"},
//        {"dim",                            "1"},
//        {"taup_bg",                        "0.1"},
//        {"Mesh",                           "oneDim"},
//        {"Problem",                        "Benchmark1D"},
//        {"startingValue_",                 "1"},
//        {"Preconditioner_S",               "SuperLU"},
//        {"Preconditioner_M",               "PointBlockJacobi"},
//        {"Problem",                        "VAcousticWaveC2Benchmark"},
//        {"ReconstructionType",             "Classical"},
//        {"sourceSpace",                    "2"},
//        {"useTaper",                       "0"},
//        {"taperRadiusSource",              "0"},
//        {"taperRadiusReceiver",            "100"},
//        {"taperExponent",                  "-0.1"},
//        {"taperIgnoreReceiverCells",       "1"},
//        {"taperIgnoreSourceCells",         "0"},
//        {"Monoparam",                      "Vp"},
//        {"shots",                          "1"}, //Taucht nicht in FWITestLinearized auf
//        {"SignalName",                     "Ricker"},
//        {"SignalFreq",                     "10"},
//        {"SignalCutoff",                   "0"},
//        {"SignalDelay",                    "0"},
//        {"numberOfSourcesPerShot",         "1"},
//        {"shots",                          "1"},
//        {"rho_bg",                         "2"  },
//        {"v_bg",                           "5.0"},
//        {"size_perturb",                   "0"},
//        {"FWIReceiverWaypoints",           "2"},//I have some waypoint error, c.f. .cpp file comment.
//        {"FWIReceiverWaypoint0",           "2.1 0"},
//        {"FWIReceiverWaypoint1",           "3.5 0"},
//        {"FWIReceiverIncludeLastWaypoint", "0"},
//        {"FWIReceiverCount0",              "20"},
//        {"UseSparseMatrix",                "1"},
//        {"f_source",                       "10"},
//        {"FWISourceWaypoints",             "2"},
//        {"FWISourceWaypoint0",             "0.5, 0"},
//        {"FWISourceWaypoint1",             "0.5, 0"},
//        {"FWISourceCount0",                "1"},
//        {"FWISourceIncludeLastWaypoint",   "0"},
//        {"numL",                           "2"},
//        {"compMeasure",                    "0"},
//        {"source_component",               "2"},
//        {"allowPlotting_M",                "1"},
//        {"allowPlotting_WF",               "1"},
//        {"plotFactor",                     "1"},
//        {"parametrization",                "taup_positive"},//taup_positive? Brauche taup (sofern das relevant hier)
//        {"T",                              "1.00"},
//        {"dt",                             "0.005"},
//        {"shots",                          "1"}, //Taucht nicht in FWITestLinearized auf
//        {"deg",                            "1"},
//        {"level",                          "8"},
//        {"plot_tStep",                     "-1"},
//        {"rkorder",                        "-2"},
//        {"Overlap",                        "dG1"},
//        {"LinearSolver",                   "LS"},
//        {"LinearVerbose",                  "-1"},
//        {"FWIReconstructRho",              "0"},
//        {"FWIReconstructV_P",              "1"},
//        {"plotV",                          "1"}
//};


#endif //FWI_FWITESTSECONDDERIVATIVE_H
