//
// Created by lionbart on 19.03.23.
//

#ifndef FWI_FWITESTSECONDDERIVATIVEADJOINT_H
#define FWI_FWITESTSECONDDERIVATIVEADJOINT_H

#include <string>
#include <map>
//Config originally taken from TestLinearized
using ConfigMap = std::map<std::string, std::string>;
const ConfigMap ConfigTestSecondDerivativeAdjoint{
        {"ConfigVerbose",                  "2"},
        {"ForwardSolver",                  "VADGTS"},
        {"Distribution",                   "RCB"},
        {"Model",                          "FWIInverse_DGTS"},
        {"CountCellsOld",                  "0"},
        {"dim",                            "1"},
        {"taup_bg",                        "0.1"},
        {"Mesh",                           "oneDim"},
        {"Problem",                        "Benchmark1D"},
        {"startingValue_",                 "1"},
        {"Preconditioner_S",               "SuperLU"},
        {"Preconditioner_M",               "PointBlockJacobi"},
        {"Problem",                        "VAcousticWaveC2Benchmark"},
        {"ReconstructionType",             "Classical"},
        {"sourceSpace",                    "2"},
        {"useTaper",                       "0"},
        {"taperRadiusSource",              "0"},
        {"taperRadiusReceiver",            "100"},
        {"taperExponent",                  "-0.1"},
        {"taperIgnoreReceiverCells",       "1"},
        {"taperIgnoreSourceCells",         "0"},
        {"Monoparam",                      "Vp"},
        {"SignalName",                     "Ricker"},
        {"SignalFreq",                     "10"},
        {"SignalCutoff",                   "0"},
        {"SignalDelay",                    "0"},
        {"numberOfSourcesPerShot",         "1"},
        {"rho_bg",                         "2"  },
        {"v_bg",                           "5.0"},
        {"size_perturb",                   "0"},
        {"FWIReceiverWaypoints",           "2"},
        {"FWIReceiverWaypoint0",           "2.1 0"},
        {"FWIReceiverWaypoint1",           "3.5 0"},
        {"FWIReceiverIncludeLastWaypoint", "0"},
        {"FWIReceiverCount0",              "20"},
        {"UseSparseMatrix",                "1"},
        {"f_source",                       "10"},
        {"FWISourceWaypoints",             "2"},
        {"FWISourceWaypoint0",             "0.5, 0"},
        {"FWISourceWaypoint1",             "0.5, 0"},
        {"FWISourceCount0",                "1"},
        {"FWISourceIncludeLastWaypoint",   "0"},
        {"numL",                           "0"},//changed from 2 to 0.
        {"compMeasure",                    "0"},
        {"source_component",               "2"},
        {"allowPlotting_M",                "1"},
        {"allowPlotting_WF",               "1"},
        {"plotFactor",                     "1"},
        {"parametrization",                "taup"},//changed to taup from taup_positive
        {"T",                              "1.00"},
        {"dt",                             "0.005"},
        {"deg",                            "1"},
        {"level",                          "8"},
        {"plot_tStep",                     "-1"},
        {"rkorder",                        "-2"},
        {"Overlap",                        "dG1"},
        {"LinearSolver",                   "LS"},
        {"LinearVerbose",                  "-1"},
        {"FWIReconstructRho",              "0"},//Wirklich 0 oder wird das irgendwo überschrieben!?
        {"FWIReconstructV_P",              "1"},
        {"plotV",                          "1"}//,
//        {"source_factor",                  "10000"}//Testweise; Relative Differenz bleibt etwa gleich. Default s_f = 1
};

#endif //FWI_FWITESTSECONDDERIVATIVEADJOINT_H
