#include "../gtests/googletest/include/gtest/gtest.hpp"
//#include <cmath>
#include "../src/Small.hpp"
#include "../src/m++.hpp"
bool operator==(const Vector &U, const Vector &V) {
    for (int i = 0; i < V.size(); ++i) {
        if ((U[i] - V[i]) > 10e-10) return false;
    }
    return true;
}

TEST(ScalarProduct, ProductProductInv
) {
int i = 0;
char **argc = nullptr;
SetConfPath("FWI",0,argc);
DPO dpo(&i, &argc);
std::string Model = "FWIForward";
auto Dcell = std::unique_ptr<dof>(nullptr);
Dcell.reset(new dof("cell",3));
double test = 1.0;
Meshes M("square4x4_0", 0, 1);
auto GDcell = std::unique_ptr<MatrixGraphs>(nullptr);
GDcell.reset(new
MatrixGraphs(M, *Dcell
));
Vector ABC(GDcell->fine());
for (
int i = 0;
i<ABC.

size();

++ i){
        ABC[i] = i;
    }
    auto SKP =[](){auto SKPint = SmallMatrix(3);
                  SKPint[0][0] = 5.0;
                  SKPint[0][1] = 2.0;
                  SKPint[0][2] = 1.5;
                  SKPint[1][0] = 2.0;
                  SKPint[1][1] = 7.0;
                  SKPint[1][2] = 1.0;
                  SKPint[2][0] = 1.0;
                  SKPint[2][1] = 1.0;
                  SKPint[2][2] = 6.0;
                  return SKPint;}();
    auto SKP_inv = SmallMatrix(SKP);
    SKP_inv.invert();
    auto Prod = product(SKP,ABC);
    auto Prod2 = product(SKP_inv,Prod);
    EXPECT_EQ(ABC,Prod2);
}
