#include "DGVAcousticAssembleBwd.hpp"
#include "DGAssemble.hpp"

void DGVAcousticAssembleBwd::RHS(double t, Vector &b) const {
    rhsAssembler->RHS(T - t, b);
}

void DGVAcousticAssembleBwd::FluxMatrixOnly(Matrix &A) const {
    DGAssemble::FluxMatrix(A, false, false);
}

void DGVAcousticAssembleBwd::FluxMatrix(Matrix &A) const {
    DGAssemble::FluxMatrix(A, true, false);
}
double DGVAcousticAssembleBwd::L2Error(double t, const Vector &u) const {
    return DGAssemble::L2Error(T - t, u);
}

void DGVAcousticAssembleBwd::PrintStep(double t, Vector &u, int step) {
    DGAssemble::PrintStep(T - t, u, step);
}

void DGVAcousticAssembleBwd::get_u_int_assemble(double t, Vector &u) const {
    DGAssemble::get_u_int_assemble(T - t, u);
}
