#ifndef _DGVISCOACOUSTICASSEMBLEBWD_HPP_
#define _DGVISCOACOUSTICASSEMBLEBWD_HPP_

#include "DGAssemble.hpp"

class DGVAcousticAssembleBwd : public DGAssemble {
    double T;
    int _printRead;
public:
    DGVAcousticAssembleBwd(std::shared_ptr<ProblemVAcoustic> _prob,
                           int printRead = -1) :
            DGAssemble(_prob, false, printRead), T(1.0),
            _printRead(printRead) {
        Config::Get("T", T, -1);
    }

    void FluxMatrix(Matrix &A) const override;

    void SystemMatrix(Matrix &S) const override {
        FluxMatrix(S);
    }

    void FluxMatrixOnly(Matrix &A) const override;

    void RHS(double t, Vector &b) const override;

    void InitialStep(double t, Vector &u);

    double L2Error(double t, const Vector &u) const override;

    void PrintStep(double t, Vector &u, int step);

    void get_u_int_assemble(double t, Vector &u) const override;

    void SetInitialValue(Vector &u) override {
        DGAssemble::get_u_int_assemble(T, u);
    }
};
#endif
