// $Header: https://svn.math.kit.edu/svn/M++/SummerSchool/TimeStepping/src/DGMatrixGraph.h 788 2017-01-16 13:24:54Z ziegler $

#ifndef _DGMatrixGraphH_
#define _DGMatrixGraphH_

#include <IDiscretization.hpp>
#include "Algebra.hpp"
#include "m++.hpp"
//#include "Overlap.hpp"
class RowEntries_dG {
    Scalar* a;
    int n;
    int nf;
    void fill (Matrix& A, const rows& R, const rows& Rf){
        n = R[0].n();
        nf = Rf[0].n();
        a = A(R[0],Rf[0]);
    }
public:
    RowEntries_dG (Matrix& A, const rows& R, const rows& Rf) { fill(A,R,Rf); }
    RowEntries_dG (Matrix& A, const cell& c, const cell& cf) {
        row r = A.find_row(c());
        row rf = A.find_row(cf());
        n = r.n();
        nf = rf.n();
        a = A(r,rf);
        //mout << OUT(n) << OUT(rf.n()) <<  OUT(A.GetEntry(r,rf)) << OUT(A.Size()-A.GetEntry(r,rf)) << endl;
    }
    RowEntries_dG (Matrix& A, const cell& c) {
        row r = A.find_row(c());
        n = nf = r.n();
        a = A(r,r);
    }
    Scalar& operator () (int k, int l) { 
        if (k*nf+l >= n*nf) {
            mout << OUT(n) << OUT(nf) << OUT(k) << OUT(l) << endl;
            
            Exit("too large");
        }
        return a[k*nf+l]; 
    }
};
//
//class CellMatrixGraph : public MatrixGraph {
//    int CellDoFs (const IDiscretization& disc, const cell& c) {
//       std::vector<short> z;
//        disc.GetDoFs().NodalDoFs(c,z);
//        return z[0];
//    }
//    void SeedCells (const IDiscretization& disc) {
//        for (cell c = mesh->cells(); c != mesh->cells_end(); ++c)
//            _rows.Insert(c(),CellDoFs(disc,c));
//        for (cell c = mesh->overlap(); c!= mesh->overlap_end();++c)
//             _rows.Insert(c(),CellDoFs(disc,c));
//    }
//    void SeedCrossPoints (const IDiscretization& disc) {
//        ExchangeBuffer E;
//        for (cell c = mesh->cells();  c != mesh->cells_end(); ++c) {
//            for (int i=0; i<c.Corners(); ++i) {
//                procset ps = mesh->find_procset(c[i]);
//                if (ps == mesh->procsets_end()) continue;
//                if (ps.size() < 3) continue;
//                for (int k=0; k<ps.size(); ++k)
//                    if (ps[k] != PPM->proc())
//                        E.Send(ps[k]) << c() << short(CellDoFs(disc,c));
//            }
//        }
//        E.Communicate();
//        for (int q=0; q<PPM->size(); ++q) {
//            if (q == PPM->proc()) continue;
//            while (E.Receive(q).size()<E.Receive(q).Size()) {
//                Point z;
//                short m;
//                E.Receive(q) >> z >> m;
//                _rows.Insert(z,m);
//            }
//        }
//    }
//    void SendProcSets () {
//        ExchangeBuffer E;
//        for (cell c = mesh->cells();  c != mesh->cells_end(); ++c) {
//            for (int i=0; i<c.Corners(); ++i) {
//                procset ps = mesh->find_procset(c[i]);
//                if (ps == mesh->procsets_end()) continue;
//                if (ps.size() < 3) continue;
//                for (int k=0; k<ps.size(); ++k)
//                    _procSets.Append(c(),ps[k]);
//            }
//        }
//        for (cell c = mesh->cells();  c != mesh->cells_end(); ++c) {
//            procset ps = _procSets.find_procset(c());
//            if (ps == _procSets.procsets_end()) continue;
//            if (ps.size() < 3) continue;
//            for (int k=0; k<ps.size(); ++k) {
//                if (ps[k] != PPM->proc()) {
//                    E.Send(ps[k]) << c() << short(ps.size());
//                    for (int i=0; i<ps.size(); ++i)
//                        E.Send(ps[k]) << short(ps[i]);
//                }
//            }
//        }
//        E.Communicate();
//        for (int q=0; q<PPM->size(); ++q) {
//            if (q == PPM->proc()) continue;
//            while (E.Receive(q).size()<E.Receive(q).Size()) {
//                Point z;
//                short m;
//                E.Receive(q) >> z >> m;
//                _procSets.Add(z,q);
//                for (int i=0; i<m; ++i) {
//                    short p;
//                    E.Receive(q) >> p;
//                    _procSets.Append(z,p);
//                }
//            }
//        }
//    }
//    void SeedNBCells () {
//        for (face f=mesh->faces(); f!=mesh->faces_end(); ++f) {
//            Point L = f.Left();
//            Point R = f.Right();
//            if (R != Infty) {
//                if (L != Infty)
//                    _rows.AddEntries(L,R);
//            } else {
//                identifyset is = mesh->find_identifyset(f());
//                if (is == mesh->identifysets_end()) continue;
//                face ff = mesh->find_face((*is)[0]);
//                _rows.AddEntries(L,ff.Left());
//            }
//        }
//    }
//public:
//    CellMatrixGraph (const Mesh& m, const IDiscretization& Disc) :
//    MatrixGraph(Disc.GetDoFs(),m) {
//        SeedCells(Disc);
//        SeedCrossPoints(Disc);
//        SeedNBCells();
//        Init(m);
//        SendProcSets();
//    }
//};



#endif
