#ifndef _DGTSHELPER_H_
#define _DGTSHELPER_H_

#define my_vectorDG vector
#include "GlobalDefinitions.hpp"
#include "VectorField.hpp"
#include "Tensor.hpp"
template< typename T >
class ShapeValuesDG : public my_vectorDG< my_vectorDG< T > > {
public:
    ShapeValuesDG(int quadrature_points, int nodal_points) {
        this->resize(quadrature_points);
        for (int q=0; q<quadrature_points; ++q)
            (*this)[q].resize(nodal_points);
    }
};

typedef ShapeValuesDG< Scalar >  ScalarShapeValuesDG;
typedef ShapeValuesDG< VectorField >  VectorShapeValuesDG;
typedef ShapeValuesDG< Tensor >  TensorShapeValuesDG;

#endif
