# print_hi('PyCharm')
import pyvista as pv
import numpy as np

def plotReal(plotter):
    plotter.screenshot('IterPlot__' + titlePrefix[j] + '_' + iter_fnName.format(nriter) + '.png')

def plotDiff(plotter):
    plotter.screenshot('DiffPlot__' + titlePrefix[j] + '_' + iter_fnName.format(nriter) + '.png')
    
def plotInitReal(plotter):
    plotter.screenshot('aa_REAL_Init__' + titlePrefix[j] + '_' + '.png')
    
def dontConfuseNames(plotter):
    plotter.screenshot('aa_REAL_Other_Init__' + titlePrefix[j] + '_' + '.png')

path = ['/home/lionbart/Desktop/Logs_Plots_MA/2023_06_21_zVp15/',
        '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_noIC_VpMono_HighResolution/',
        '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_IC_RhoMono_HighResolution/',
        '/home/lionbart/Desktop/Logs_Plots_MA/2023_06_30_MultiHighRes_SO/',
        '/home/lionbart/Desktop/Logs_Plots_MA/2023_07_06_Multi_FO_Iter10/'
        ]
titlePrefix = ['Vp', 'noICVP', 'Rho', 'MultiSO', 'MultiFO']
prefix = ['Vp', 'Vp', 'Rho']

real_fn = 'Vp_fwi_m_real.vtu'
initial_fn = 'Vp_fwi_m_initial.vtu'
iter_fn = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}.vtu'
iter_fnName = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}'

######Pseudoconfig Area######
makeMapping = False
#frame = [450, 1500, 300, 1690]#Alt... Nicht ROI=RegionOfInterest (CRC Paper) beachtet ://
frame = [650, 1300, 370, 1620]
zoom = 2.2
createPlot = True
plotOffScreen = False #Der Screenshot ist anders, wenn offScreen geplotted wird :(( wtf



with open('Fehler.txt', 'w') as outfile:
    outfile.write('Große Fehlerberechnung ' + '\n')
with open('FehlerInfNorm.txt', 'w') as outfile:
    outfile.write('Infinity Norm für Tikzpicture formatiert ' + '\n')

for j in range(3):  # range(len(path)):
    if j == 1:
        initial_other_fn = 'Rho_fwi_m_real.vtu'
    
    if j == 2:
        real_fn = 'Rho_fwi_m_real.vtu'
        initial_fn = 'Rho_fwi_m_initial.vtu'
        iter_fn = 'Rho__fwi_FWISO_iterate_m_allshots_5_{}.vtu'
        iter_fnName = 'Rho__fwi_FWISO_iterate_m_allshots_5_{}'
        initial_other_fn = 'Vp_fwi_m_initial.vtu'

    # real_centers = pv.read(path+real_fn).cell_centers()
    # exit()
    real_vtu = pv.read(path[j] + real_fn)
    real_vtu_cells = real_vtu.cell_centers()
    initial_vtu = pv.read(path[j] + initial_fn)
    #initial_other_vtu = pv.read(path[j] + initial_other_fn)
    initial_vtu_cells = initial_vtu.cell_centers()
    #initial_other_vtu_cells = initial_other_vtu.cell_centers()
    iter_vtu = pv.read(path[j] + iter_fn.format(0))

    iter_vtu_celldata = iter_vtu.cell_data[prefix[j]]
    real_vtu_celldata = real_vtu.cell_data[prefix[j]]
    initial_vtu_celldata = initial_vtu.cell_data[prefix[j]]
    #if j == 1:
        #initial_other_vtu_celldata = initial_other_vtu.cell_data['Rho']
    #elif j == 2:
        #initial_other_vtu_celldata = initial_other_vtu.cell_data['Vp']
    result_vtu = pv.read(path[j] + real_fn)
    result_vtu_celldata = result_vtu.cell_data[prefix[j]]

    pointmapping = []  # Hält Geometrie fest (die teils nicht übereinstimmt)
    if makeMapping:  # always... otherwise weird
        for (i, p) in enumerate(real_vtu_cells.points):
            if frame[0] > p[0] or p[0] > frame[1]:
                #if 1000 > p[0] or p[0] > 1100:
                result_vtu_celldata[i] = 0
                continue
            elif frame[2] > p[1] or p[1] > frame[3]:
                #elif 700 > p[1] or p[1] > 800:
                result_vtu_celldata[i] = 0
                continue
            pointmapping.append((i, iter_vtu.find_containing_cell(p)))
        pointmapSave = np.array(pointmapping)
        file = open(titlePrefix[j] + "_pointmapping.npy", "wb")
        # save array to the file
        np.save(file, pointmapSave)
        # close the file
        file.close
    elif not makeMapping:
        file = open(titlePrefix[j] + "_pointmapping.npy", "rb")
        pointmapping = np.load(file)
        file.close
        for (i, p) in enumerate(real_vtu_cells.points):
            if frame[0] > p[0] or p[0] > frame[1]:
                result_vtu_celldata[i] = 0
            elif frame[2] > p[1] or p[1] > frame[3]:
                result_vtu_celldata[i] = 0
                
    with open('Fehler.txt', 'a') as outfile:
        outfile.write('Fehlerberechnung ' + titlePrefix[j] + '\n')
    with open('FehlerInfNorm.txt', 'a') as outfile:
        outfile.write('Fehlerberechnung InfNorm' + titlePrefix[j] + '\n')
    
    #Berechne Fehler: Real - Homogen
    print(titlePrefix[j] + '_' + prefix[j] + 'Homogenes Feld Wert')
    print(initial_vtu_celldata[0])
    for t in pointmapping:
        result_vtu_celldata[t[0]] = real_vtu_celldata[t[0]] - initial_vtu_celldata[t[1]]
    RealMinusInit = np.array(result_vtu_celldata)
    RealMinusInitNorm = np.linalg.norm(RealMinusInit)
    RealMinusInitInfNorm = max(abs(RealMinusInit))
    
    ###  Plot Config
    legende = dict(height=0.1, position_x=0.89, position_y=0.5)#Gut aktuell!!
    legendeDiff = dict(height=0.1, position_x=0.2, position_y=0.06)
    annotationsDiff = {0: "0"}
    if prefix[j] == 'Vp':
        annotationsIter = {3500: "3500"}
        climIter = [3250, 3750]#Angepasst an Start.
        climIter = [3200, 3800]#Angepasst an Endskale (von Paraview abgeschaut)
        climReal = [3325, 3850]#3500 - 175 und 3500 + 350
        climReal = [3150, 3850]#3500 - 350 und 3500 + 350   Idee, dass symmetrie plotting arbeit spart...
        #Idee: Das zu Array machen und einlesen
    elif prefix[j] == 'Rho':
        annotationsIter = {2000: "2000"}
        climIter = [1900, 2100]#Eventuell für höhere Iterationen schlecht!?
        climReal = [1900, 2200]#2000 - 100 und 2000 + 200
        climReal = [1800, 2200]#2000 - 200 und 2000 + 200   Idee, dass symmetrie plotting arbeit spart...
    
    norm = np.zeros(10)
    infnorm = np.zeros(10)
    for nriter in range(10):  # 10):
        plPlot = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)  # Plotter für Ergebnis bauen
        pl = pv.Plotter(window_size=(600, 1000), off_screen = True)  # Plotter für Differenz bauen
        
        iter_vtu_celldata = pv.read(path[j] + iter_fn.format(nriter)).cell_data[prefix[j]]
        print('Iteration Path: ' + path[j] + iter_fn.format(nriter))

        for t in pointmapping:
            result_vtu_celldata[t[0]] = real_vtu_celldata[t[0]] - iter_vtu_celldata[t[1]]
            #iteration
            #iter_vtu_celldata[t[0]] = 
        # result_vtu.plot() #abgelöst durch pl = pv.Plotter()
        
        #1. Versuch: (rausscheibeen)
        #add_legend (pyvista ding  argument loc
        
        ### Fehlerberechnung
        resultNp = np.array(result_vtu_celldata)
        norm[nriter] = np.linalg.norm(resultNp)
        infnorm[nriter] = max(abs(resultNp))
        with open('Fehler.txt', 'a') as outfile:
            outfile.write('(' + str(nriter + 1) + ',' + str(np.around(norm[nriter]/RealMinusInitNorm, 4)) + ')')
        with open('FehlerInfNorm.txt', 'a') as outfile:
            outfile.write('(' + str(nriter + 1) + ',' + str(np.around(infnorm[nriter]/RealMinusInitInfNorm, 4)) + ')')
        
        iter_vtu = pv.read(path[j] + iter_fn.format(nriter))
        iter_vtu_celldata = iter_vtu.cell_data[prefix[j]]
        

        legendeTest = dict(background_color = [0,0,0],
            fmt='%4.0f', n_labels = 5,
            vertical = True, position_x = 0.8, position_y = 0.1, height = 0.8, width= 0.2,
            label_font_size = 30, title_font_size = 40,
            #interactive = True, #shadow = False, outline = False,
            color = [0,0,0],)
        
        if createPlot:
            ### Plot Iteration (For figures in MA) ###
            _ = plPlot.add_mesh(iter_vtu, scalar_bar_args = legendeTest, clim=climReal, cmap = 'RdYlBu',)
                #annotations = annotationsIter,) 
            #_ = plPlot.add_mesh(iter_vtu, show_scalar_bar=False)
            #_ = plPlot.add_mesh(iter_vtu, scalar_bar_args = legende, annotations = annotationsIter, clim=climIter)
            #plPlot.show_axes()
            #plPlot.camera.position = (0.0, 0.0, 1000.0)
            plPlot.camera_position = 'xy'
            #print(plPlot.camera_position)
            #plPlot.camera_position = [(1000.0014953613281, 1000.0, 20438.471894650203),#position
                                     #(1000.0014953613281, 1000.0, 0.0),                #focal point
                                     #(0.0, 1.0, 0.0)]                                  #set_viewup
            plPlot.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
                                     (1100.0014953613281, 1000.0, 0.0),                #focal point
                                     (0.0, 1.0, 0.0)]                                  #set_viewup

            plPlot.camera.zoom(zoom)
            #plPlot.plot(cmap = 'RdYlBu') 
            plPlot.show(before_close_callback=plotReal)
            #print(plPlot.camera_position)      #Seeeeehr hilfreich. Nach rumschieben mit interactive ausgabe der aktuellen pos.

            ### Plot Diff ### No longer supported, since no plot made it into the Thesis.
            #_ = pl.add_mesh(result_vtu, scalar_bar_args = legendeTest, cmap = 'RdYlBu',)
            #, annotations=annotationsDiff)
            #pl.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
            #                         (1100.0014953613281, 1000.0, 0.0),                #focal point
            #                         (0.0, 1.0, 0.0)]                                  #set_viewup
            #pl.camera.zoom(zoom)
            #pl.show(before_close_callback=plotDiff)
            #print(pl.camera_position)
            
        if nriter == 0 and createPlot == True:
            #CreatePlot of Real_Init; Benennung leider etwas verwirrt... Herzlichen Glückwunsch
            plVp = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)
            plRho = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)
            _ = plVp.add_mesh(real_vtu, scalar_bar_args = legendeTest, clim=climReal, cmap = 'RdYlBu')
            #annotations = annotationsIter, 
            _ = plRho.add_mesh(initial_vtu, scalar_bar_args = legendeTest, clim=climReal, cmap = 'RdYlBu')
            
            plVp.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
                                     (1100.0014953613281, 1000.0, 0.0),                #focal point
                                     (0.0, 1.0, 0.0)]                                  #set_viewup
            plRho.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
                                     (1100.0014953613281, 1000.0, 0.0),                #focal point
                                     (0.0, 1.0, 0.0)]                                  #set_viewup
            
            plVp.camera.zoom(zoom)
            plRho.camera.zoom(zoom)
            plVp.show(before_close_callback=plotInitReal)
            plRho.show(before_close_callback=dontConfuseNames)
            
            ####pl.show(screenshot = 'diffplot'+iter_fn.format(nriter)+'.png')

        # window_size = (200, 200),
    #Berechnung Fehler und Relativer Fehler + Abspeichern
    normNormalized = norm/RealMinusInitNorm#norm[0]
    normNormalized = np.around(normNormalized, 4)
    with open('Fehler.txt', 'a') as outfile:
        outfile.write('\n' + repr(norm) + '\n')
        outfile.write(repr(normNormalized) + '\n')
        outfile.write('\n\n')
    
    infnormNormalized = infnorm/RealMinusInitInfNorm
    infnormNormalized = np.around(infnormNormalized, 4)
    with open('FehlerInfNorm.txt', 'a') as outfile:
        outfile.write('\n' + repr(infnorm) + '\n')
        outfile.write(repr(infnormNormalized) + '\n')
        outfile.write('\n\n')

exit()

# pl.view_xy()
# pl.export_obj('diffplot'+iter_fn.format(nriter)+'.obj') #Kann man machen, muss man aber nicht.
# pl.save_graphic('diffplot'+iter_fn.format(nriter)+'.svg')

# CR Idee# savePlot(path+'diffplot'+iter_fn.format(nriter)+'.obj', 'RealPlotMATPLOTLIB'+iter_fnName.format(nriter)+'.png', 3300, 3740)

# import pyvista as pv
# >>> true_vtu = pv.read('Vp_fwi_m_real.vtu')
# >>> true_vtu_data = pv.read('Vp_fwi_m_real.vtu'

# >>> true_vtu_data = true_vtu.cell_data['Vp']

# >>> true_vtu_data
# pyvista_ndarray([3500., 3500., 3500., ..., 3500., 3500., 3500.],
#                dtype=float32)
# >>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_14.vtu').cell_data['Vp']
# >>> iter_data
# pyvista_ndarray([3500., 3500., 3500., ..., 3500., 3500., 3500.],
#                dtype=float32)
# >>> diff = true_vtu_data-iter_data

# >>> import numpy as np
# >>> diffnp = np.array(diff)
# >>> diffnp
# array([0., 0., 0., ..., 0., 0., 0.], dtype=float32)
# >>> diffnp.norm()
# Traceback (most recent call last):
#  File "<stdin>", line 1, in <module>
# AttributeError: 'numpy.ndarray' object has no attribute 'norm'
# >>> diff.linalg.norm()

# >>> np.linalg.norm(diff)
# 9635.88
# >>> initial_data = pv.read('Vp_fwi_m_initial.vtu').cell_data['Vp']
# >>> np.linalg.norm(initial_data-true_vtu_data)
# 6858.548
# >>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_1.vtu').cell_data['Vp']
# >>> diff = true_vtu_data-iter_data
# >>> np.linalg.norm(diff)
# 8466.148
# >>> np.linalg.norm(diff,ord=2)
##8466.148
# >>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_0.vtu').cell_data['Vp']
# >>> diff = true_vtu_data-iter_data
# >>> np.linalg.norm(diff,ord=2)
# 8278.743
##

# See PyCharm help at https://www.jetbrains.com/help/pycharm/

