# Error Berechnung für Multi Rekonstruktionen
import pyvista as pv
import numpy as np

def plotReal(plotter):#Das ist dum benannt, aber bleibt halt jetzt so. solle: "plotIter" heißen
    plotter.screenshot('IterPlot__' + titlePrefix[j] + '_' + iter_fnName.format(nriter) + '.png')

def plotDiff(plotter):
    plotter.screenshot('DiffPlot__' + titlePrefix[j] + '_' + iter_fnName.format(nriter) + '.png')
    
def plotInitReal(plotter):
    plotter.screenshot('_REAL_Init__' + titlePrefix[j] + '_' + prefix[k] + '.png')

path = ['/home/lionbart/Desktop/Logs_Plots_MA/2023_06_30_MultiHighRes_SO/',
        '/home/lionbart/Desktop/Logs_Plots_MA/2023_07_06_Multi_FO_Iter10/'
        ]
titlePrefix = ['MultiSO', 'MultiFO']
prefix = ['Vp', 'Rho']


######Pseudoconfig Area######
makeMapping = False
frame = [650, 1300, 370, 1620]
zoom = 2.2
createPlot = True #Bei True musst du q drücken die ganze Zeit oder das fixen
plotOffScreen = False #Der Screenshot ist anders, wenn offScreen geplotted wird :(( wtf

with open('FehlerMulti.txt', 'w') as outfile:
    outfile.write('Große Fehlerberechnung ' + '\n')
with open('FehlerMultiInfNorm.txt', 'w') as outfile:
    outfile.write('Infinity Norm für Tikzpicture formatiert ' + '\n')

for j in range(2): #Schleife über path
    for k in range(2): #Schleife über prefix
        if j == 0 and k == 0:
            real_fn = 'Vp_fwi_m_real.vtu'
            initial_fn = 'Vp_fwi_m_initial.vtu'
            iter_fn = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}.vtu'
            iter_fnName = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}'
            climIter = [3400, 3640]#ist das noch aktuell und gewollt?
        elif j == 0 and k == 1:
            real_fn = 'Rho_fwi_m_real.vtu'
            initial_fn = 'Rho_fwi_m_initial.vtu'
            iter_fn = 'Rho__fwi_FWISO_iterate_m_allshots_5_{}.vtu'
            iter_fnName = 'Rho__fwi_FWISO_iterate_m_allshots_5_{}'
        elif j == 1 and k == 0:
            real_fn = 'Vp_fwi_m_real.vtu'
            initial_fn = 'Vp_fwi_m_initial.vtu'
            iter_fn = 'Vp__fwi_CGREGINNCanonic_iterate_m_allshots_5_{}.vtu'
            iter_fnName = 'Vp__fwi_CGREGINNCanonic_iterate_m_allshots_5_{}'
        elif j == 1 and k == 1:
            real_fn = 'Rho_fwi_m_real.vtu'
            initial_fn = 'Rho_fwi_m_initial.vtu'
            iter_fn = 'Rho__fwi_CGREGINNCanonic_iterate_m_allshots_5_{}.vtu'
            iter_fnName = 'Rho__fwi_CGREGINNCanonic_iterate_m_allshots_5_{}'
        else:
            print('ich verstehe das noch nicht. Filenames ändern ist schwierig')
        print('j pathschleife = ' + str(j) + '  und k = ' + str(k) + ' und ' + iter_fnName)
        
        real_vtu = pv.read(path[j] + real_fn)
        real_vtu_cells = real_vtu.cell_centers()
        initial_vtu = pv.read(path[j] + initial_fn)
        initial_vtu_cells = initial_vtu.cell_centers()
        iter_vtu = pv.read(path[j] + iter_fn.format(0))
        
        iter_vtu_celldata = iter_vtu.cell_data[prefix[k]]
        real_vtu_celldata = real_vtu.cell_data[prefix[k]]
        initial_vtu_celldata = initial_vtu.cell_data[prefix[k]]
        result_vtu = pv.read(path[j] + real_fn)
        result_vtu_celldata = result_vtu.cell_data[prefix[k]]
        
        pointmapping = []  # Hält Geometrie fest (die teils nicht übereinstimmt)
        if makeMapping:
            for (i, p) in enumerate(real_vtu_cells.points):
                if frame[0] > p[0] or p[0] > frame[1]:
                    #if 1000 > p[0] or p[0] > 1100:
                    result_vtu_celldata[i] = 0
                    continue
                elif frame[2] > p[1] or p[1] > frame[3]:
                    #elif 700 > p[1] or p[1] > 800:
                    result_vtu_celldata[i] = 0
                    continue
                pointmapping.append((i, iter_vtu.find_containing_cell(p)))
            pointmapSave = np.array(pointmapping)
            file = open(titlePrefix[j] + '_' + prefix[k] + "_pointmapping.npy", "wb")
            # save array to the file
            np.save(file, pointmapSave)
            # close the file
            file.close
        else:
            #Reuse the already created pointmapping file.
            file = open(titlePrefix[j] + '_' + prefix[k] + "_pointmapping.npy", "rb")
            pointmapping = np.load(file)
            file.close
            for (i, p) in enumerate(real_vtu_cells.points):
                if frame[0] > p[0] or p[0] > frame[1]:
                    result_vtu_celldata[i] = 0
                elif frame[2] > p[1] or p[1] > frame[3]:
                    result_vtu_celldata[i] = 0
                
        with open('FehlerMulti.txt', 'a') as outfile:
            outfile.write('Fehlerberechnung ' + titlePrefix[j] + '_' + prefix[k] + '\n')
        with open('FehlerMultiInfNorm.txt', 'a') as outfile:
            outfile.write('Fehlerberechnung InfNorm' + titlePrefix[j] + '_' + prefix[k] + '\n')
        
        #Berechne Fehler: Real - Homogen
        print(titlePrefix[j] + '_' + prefix[k] + 'Homogenes Feld Wert')
        for t in pointmapping:
            result_vtu_celldata[t[0]] = real_vtu_celldata[t[0]] - initial_vtu_celldata[t[1]]
        RealMinusInit = np.array(result_vtu_celldata)
        RealMinusInitNorm = np.linalg.norm(RealMinusInit)
        #RealMinusInit = np.reshape(RealMinusInit, -1)
        
        RealMinusInitInfNorm = max(abs(RealMinusInit))
        #np.linalg.norm(RealMinusInit, ord=np.inf)
        
        norm = np.zeros(10)
        infnorm = np.zeros(10)
        for nriter in range(10):  # 10):
            plPlot = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)  # Plotter für Ergebnis bauen
            #pl = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)  # Plotter für Differenz bauen
            
            iter_vtu_celldata = pv.read(path[j] + iter_fn.format(nriter)).cell_data[prefix[k]]
            for t in pointmapping:
                result_vtu_celldata[t[0]] = real_vtu_celldata[t[0]] - iter_vtu_celldata[t[1]]
            ### Fehlerberechnung
            resultNp = np.array(result_vtu_celldata)
            norm[nriter] = np.linalg.norm(resultNp)
            infnorm[nriter] = max(abs(resultNp))
            #Formatierung schon für tikzpicture
            with open('FehlerMulti.txt', 'a') as outfile:
                outfile.write('(' + repr(nriter + 1) + ',' + str(np.around(norm[nriter]/RealMinusInitNorm, 4)) + ')')
            with open('FehlerMultiInfNorm.txt', 'a') as outfile:
                outfile.write('(' + repr(nriter + 1) + ',' + str(np.around(infnorm[nriter]/RealMinusInitInfNorm, 4)) + ')')
            
            
            ### Plot Config
            legende = dict(height=0.1, position_x=0.2, position_y=0.06)#Gut aktuell!!
            legendeDiff = dict(height=0.1, position_x=0.2, position_y=0.06)
            annotationsDiff = {0: "0"}
            if prefix[k] == 'Vp':
                annotationsIter = {3500: "3500"}
                climIter = [3250, 3750]#äEventuell für höhere Iterationen schlecht!?
                climReal = [3325, 3850]#Neu: 3335 und 3850, damit Farben ähnlich zu Monoparam #Alt:3500 - 175 und 3500 + 175
                climReal = [3325, 3675]#3500 - 175 und 3500 + 175   Idee, dass symmetrie plotting arbeit spart...
            elif prefix[k] == 'Rho':
                annotationsIter = {2000: "2000"}
                climIter = [1900, 2100]#Eventuell für höhere Iterationen schlecht!?
                climReal = [1900, 2200]#Neu 1900, 2200, s.o. #Alt:2000 - 100 und 2000 + 100
                climReal = [1900, 2100]#2000 - 200 und 2000 + 200   Idee, dass symmetrie plotting arbeit spart...
            
            iter_vtu = pv.read(path[j] + iter_fn.format(nriter))
            iter_vtu_celldata = iter_vtu.cell_data[prefix[k]]
            
            legendeTest = dict(background_color = [0,0,0],
                fmt='%4.0f', n_labels = 5,
                vertical = True, position_x = 0.8, position_y = 0.1, height = 0.8, width= 0.2,
                label_font_size = 30, title_font_size = 40,
                #interactive = True, #shadow = False, outline = False,
                color = [0,0,0],)
            
            if createPlot:
                ### Plot Iteration (For figures in MA)
                _ = plPlot.add_mesh(iter_vtu, scalar_bar_args = legendeTest, clim=climReal, cmap = 'RdYlBu') #, annotations=annotationsIter)
                plPlot.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
                                     (1100.0014953613281, 1000.0, 0.0),                #focal point
                                     (0.0, 1.0, 0.0)]                                  #set_viewup
                #plPlot.camera_position = 'xy'
                #plPlot.show_axes()
                plPlot.camera.zoom(zoom)
                print(plPlot.camera_position)
                plPlot.show(before_close_callback=plotReal)

                ### Plot Diff
                #_ = pl.add_mesh(result_vtu, scalar_bar_args = legendeDiff, annotations=annotationsDiff, cmap = 'RdYlBu')
                #pl.set_viewup([0, 1, 0])
                #pl.camera.zoom(zoom)
                ####pl.show(screenshot = 'diffplot'+iter_fn.format(nriter)+'.png')
                #pl.show(before_close_callback=plotDiff)
            if nriter == 0 and createPlot == True:
                #CreatePlot of Real_Init
                plVp = pv.Plotter(window_size=(600, 1000), off_screen = plotOffScreen)
                _ = plVp.add_mesh(real_vtu, scalar_bar_args = legendeTest, clim=climReal, cmap = 'RdYlBu')
                #, annotations = annotationsIter
                plVp.camera_position = [(1100.0014953613281, 1000.0, 6512.327012542534),#position
                                     (1100.0014953613281, 1000.0, 0.0),                #focal point
                                     (0.0, 1.0, 0.0)]                                  #set_viewup
                plVp.camera.zoom(zoom)
                plVp.show(before_close_callback=plotInitReal)
                ####pl.show(screenshot = 'diffplot'+iter_fn.format(nriter)+'.png')

            # window_size = (200, 200),
        norm = np.array(norm)
        normNormalized = norm/RealMinusInitNorm#norm[0]
        normNormalized = np.around(normNormalized, 4)
        with open('FehlerMulti.txt', 'a') as outfile:
            outfile.write('\n' + repr(norm) + '\n')
            outfile.write(repr(normNormalized) + '\n')
            outfile.write('\n\n')
        
        infnormNormalized = infnorm/RealMinusInitInfNorm
        infnormNormalized = np.around(infnormNormalized, 4)
        with open('FehlerMultiInfNorm.txt', 'a') as outfile:
            outfile.write('\n' + repr(infnorm) + '\n')
            outfile.write(repr(infnormNormalized) + '\n')
            outfile.write('\n\n')

