##!/usr/bin/python3
# scp Procs.vtu tx6298@os-login.lsdf.kit.edu:/lsdf/kit/ianm/projects/mppci/fwi/shot-on-horeka/2022-07-21_13:30:39/vtu/
from datetime import datetime
import os, sys


def find_gitlab_command(file_reader, ci_job_name_):
    while True:
        line = file_reader.readline()
        if line.startswith(ci_job_name_):
            break
        if not line:
            exit("gitlab command not found!")


def find_salloc_lines(file_reader):
    sallocLines = []
    while True:
        line = file_reader.readline()
        if line.find('salloc') > 0:
            while line.find('salloc') > 0:
                sallocLines.append(line)
                line = file_reader.readline()
            return sallocLines
        if not line:
            exit("no salloclines  found!")


def make_sallocstrings_to_runnable_strings(salloc_strings_):
    runstrings_ = []
    cnt = 0
    for salloc_string in salloc_strings_:
        S = ' PlotPath=' + ci_job_name + '/' + str(cnt) + '/'
        S = S + ' logfile=' + ci_job_name + '/' + str(cnt) + '/' + ci_job_name
        cnt = cnt + 1
        spli = salloc_string.split(' ')
        spli[-1] = spli[-1].strip()
        spli.reverse()
        mpi_options_found = False
        for p in spli:
            if p.startswith('logfile') or p.startswith('Plotpath'):
                print(p + 'entry detected! This will not be used!')
                continue
            if p.find('${CI_JOB_NAME}') > 0:
                changedp = p[:p.find('${CI_JOB_NAME}')] + ci_job_name
                p = changedp
            if p == 'mpirun':
                mpi_options_found = True
                S = p + ' -n ' + nr_processes + ' ' + S
                runstrings_.append(S)
                break
            if mpi_options_found is False:
                S = " " + p + S
    return runstrings_


scc_alias = sys.argv[1]
project_path = sys.argv[2]
ci_job_name = sys.argv[3]
nr_processes = sys.argv[4]
LSDFPrefix = scc_alias + '@os-login.lsdf.kit.edu'
print("Executing job" + ci_job_name + "With " + nr_processes + " processors")
gitlab_file_reader = open('../.gitlab-ci.yml')
find_gitlab_command(gitlab_file_reader, ci_job_name)
salloc_strings = find_salloc_lines(gitlab_file_reader)
runstrings = make_sallocstrings_to_runnable_strings(salloc_strings)
print(runstrings)
date = datetime.now().isoformat(timespec='seconds').replace(':', '-')
pathstring = project_path + ci_job_name + '/' + date
cnt = 0
ssh_mkdir_command = 'ssh -t ' + LSDFPrefix + ' \"mkdir {:}\"'
vtu_str = '/{:}/vtu/'
log_str = '/{:}/log/'
data_str = '/{:}/data/'

Debug = False
if Debug is True:
    print('cmake ..')
    print('make -j')
    print('mkdir ' + ci_job_name)
else:
    os.system('cmake ..')
    os.system('make -j')
    os.system('mkdir ' + ci_job_name)

for runstring in runstrings:
    vtuname = pathstring + vtu_str.format(str(cnt))
    logname = pathstring + log_str.format(str(cnt))
    dataname = pathstring + data_str.format(str(cnt))
    mkvtupath = ssh_mkdir_command.format(vtuname)
    mklogpath = ssh_mkdir_command.format(logname)
    mkdatapath = ssh_mkdir_command.format(dataname)
    if Debug is True:
        print(runstring)
        print(ssh_mkdir_command.format(project_path + ci_job_name + '/'))
        print(ssh_mkdir_command.format(pathstring + '/'))
        print(ssh_mkdir_command.format(pathstring + '/' + str(cnt) + '/'))
        print(mkvtupath)
        print(mklogpath)
        print(mkdatapath)
        print('scp ' + ci_job_name + str(cnt) + '/*.vtu ' + LSDFPrefix + ":" + vtuname)
        print('scp ' + ci_job_name + '/' + str(cnt) + '/*.log ' + LSDFPrefix + ":" + logname)
    else:
        os.system(runstring)
        os.system(ssh_mkdir_command.format(project_path + ci_job_name + '/'))
        os.system(ssh_mkdir_command.format(pathstring + '/'))
        os.system(ssh_mkdir_command.format(pathstring + '/' + str(cnt) + '/'))
        os.system(mkvtupath)
        os.system(mklogpath)
        os.system(mkdatapath)
        os.system('scp ' + ci_job_name + '/' + str(cnt) + '/*.vtu ' + LSDFPrefix + ":" + vtuname)
        os.system('scp ' + ci_job_name + '/' + str(cnt) + '/*.log ' + LSDFPrefix + ":" + logname)
    cnt = cnt + 1

if Debug is True:
    print('tmux capture-pane -pS - >' + ci_job_name + date + '-tmux.output')
    print('scp ' + ci_job_name + date + 'tmux.output ' + LSDFPrefix + ":" + pathstring)
    print('tmux kill-session')
else:
    os.system('tmux capture-pane -pS - >' + ci_job_name + date + '-tmux.output')
    os.system('scp ' + ci_job_name + date + 'tmux.output ' + LSDFPrefix + ":" + pathstring)
    os.system('tmux kill-session')
