#!/usr/bin/env python3

from pprint import pprint

from mpp_mesh import MppMesh, MppPoint, MppCell, isclose
import sys

dim_x = sys.argv[1]
dim_y = sys.argv[2]
dim_cells = sys.argv[3]
dest = sys.argv[4]

#print(f"creating '{dim_size}' mesh of '{dim_cells}' cells in '{dest}'")

dim_x = dim_x.split(":")
dim_y = dim_y.split(":")
min_x, max_x = float(dim_x[0]), float(dim_x[1])
min_y, max_y = float(dim_y[0]), float(dim_y[1])

cells_x, cells_y = map(int, dim_cells.split("x"))

geo = MppMesh()

# create points
hx, hy = (max_x-min_x)/cells_x, (max_y-min_y)/cells_y

for ix in range(cells_x+1):
    for iy in range(cells_y+1):
        geo.points.append(MppPoint(min_y + ix*hx, min_y + iy*hy))

#pprint(geo.points)

# create cells
for ix in range(cells_x):
    for iy in range(cells_y):
        subdomain = 0
        off = ix*(cells_y+1) + iy
        geo.cells.append(MppCell(4, subdomain, 
                                 [off,               off + 1, 
                                  off + 1 + cells_x, off + 1 + cells_x + 1], geo.points))

#pprint(geo.cells)


def bnd(f):
    return 2
    
geo.set_bnd_cond(outer_value=bnd)

print(geo)

open(dest, "w").write(str(geo))