import numpy as np
from seismogram_lib import FWISeismogram
from numpy.fft import fft, ifft, fftfreq, fftshift, ifftshift
import matplotlib.pyplot as plt
from scipy.signal import butter,filtfilt
import plotly.graph_objects as go

def butter_lowpass_filter(data, cutoff, fs, order,nyq):
    normal_cutoff = cutoff / nyq
    # Get the filter coefficients 
    b, a = butter(order, normal_cutoff, btype='low', analog=False)
    y = filtfilt(b, a, data)
    return y
#s2 = FWISeismogram.readFromFile('Test')
#s2 = FWISeismogram.readFromFile('Test_deg3_lv0')
#s = FWISeismogram.readFromFile('Test_lvl2')
s = FWISeismogram.readFromFile('Test_lv0_normal_config')
s2 = FWISeismogram.readFromFile('Test_lv0_bigger_timestep_normal_config')

#s2 = FWISeismogram.readFromFile('Test_lv1_true')
#s = FWISeismogram.readFromFile('Test_lv0_normal_config')
#s2 = FWISeismogram.readFromFile('Test_lv1_normal_config')
s3 = FWISeismogram.readFromFile('Test_lv2_normal_config')


signal = s.toArrays(comp=2)[1][:1000,0]
time1 = s.toArrays(comp=2)[0][:1000]
signal2 = s2.toArrays(comp=2)[1][:100,0]
time2 = s2.toArrays(comp=2)[0][:100]
signal3 = s3.toArrays(comp=2)[1][:1000,0]
time3 = s3.toArrays(comp=2)[0][:1000]
T  = 0.8
fs = 8000

T2  = 0.8
fs2 = 800
nyq2 = 0.5 *fs2

cutoff = 5
nyq = 0.5 * fs
order = 2
n = int(T*fs)
y = butter_lowpass_filter(signal, cutoff, fs, order,nyq)
y2 = butter_lowpass_filter(signal2, cutoff, fs, order,nyq2)
y3 = butter_lowpass_filter(signal3, cutoff, fs, order,nyq)

plt.plot(time1,y)
#plt.plot(time1,signal)
#plt.plot(time2,signal2)
plt.plot(time2,y2)
plt.plot(time3,y3)
diff1 = y2-y3

#s2 = FWISeismogram.readFromFile('/tmp/s_sol')
#s2 = FWISeismogram.readFromFile('Test_lv4_deg')

#signal2 = s2.toArrays(comp=2)[1][:3500,0]*1./1.3
#signal2_fft = fftshift(fft(signal2))

#signal = s.toArrays(comp=2)[1][:3500,0]
#signal_fft = fftshift(fft(signal))#
#N=len(signal)
#N2=len(signal2)
#freqs = fftshift(fftfreq(N,0.000125))
#freqs2 = fftshift(fftfreq(N2,0.000125))

#plt.plot(freqs[N//2:N//2+40],abs(signal_fft)[N//2:N//2+40])
#plt.plot(freqs2[N//2:N//2+40],abs(signal2_fft)[N//2:N//2+40])

plt.show()
