import pyvista as pv
import numpy as np
path='/home/lionbart/Desktop/Logs_Plots_MA/2023_06_27_noIC_VpMono_HighResolution/'
real_fn = 'Vp_fwi_m_real.vtu'
initial_fn = 'Vp_fwi_m_initial.vtu'
iter_fn = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}.vtu'
iter_fnName = 'Vp__fwi_FWISO_iterate_m_allshots_5_{}'
#real_fn = 'Vp_fwi_m_real.csv'
#initial_fn = 'Vp_fwi_m_initial.csv'
#iter_fn = 'Vp__fwi_FWISO_iterate_m_allshots_5_0.csv'

def plotReal(plotter):
    plotter.screenshot('DiffPlot'+iter_fnName.format(nriter)+'.png')

def plotDiff(plotter):
    plotter.screenshot('ResultPlot'+iter_fnName.format(nriter)+'.png')

#real_centers = pv.read(path+real_fn).cell_centers()
#exit()
real_vtu = pv.read(path+real_fn)
real_vtu_cells=real_vtu.cell_centers()
initial_vtu = pv.read(path+initial_fn)
iter_vtu = pv.read(path+iter_fn.format(0))

iter_vtu_celldata = iter_vtu.cell_data['Vp']
real_vtu_celldata=real_vtu.cell_data['Vp']
result_vtu = pv.read(path+real_fn)
result_vtu_celldata = result_vtu.cell_data['Vp']
#initial_data = pv.read(path+initial_fn)
#iter_data = pv.read(path+iter_fn)
pointmapping =[]        #Hält Geometrie fest (die teils nicht übereinstimmt)
for (i,p) in enumerate(real_vtu_cells.points):
    #if 450 > p[0] or p[0] > 1500:
    if 1000 > p[0] or p[0] > 1100:
        result_vtu_celldata[i] = 0
        continue
    elif  700 > p[1] or p[1] > 800:
    #elif  300 > p[1] or p[1] > 1690:
        result_vtu_celldata[i] = 0
        continue
    pointmapping.append((i,iter_vtu.find_containing_cell(p)))

#Plot Real Initial Field
#plReal = pv.Plotter()
#_ = plReal.add_mesh(real_vtu)

for nriter in range(2):
    plPlot = pv.Plotter()   #Plotter für Ergebnis bauen
    pl = pv.Plotter()   #Plotter für Differenz bauen
    
    iter_vtu_celldata = pv.read(path+iter_fn.format(nriter)).cell_data['Vp']
    
    for t in pointmapping:
        result_vtu_celldata[t[0]] = real_vtu_celldata[t[0]] - iter_vtu_celldata[t[1]]
    #result_vtu.plot() #abgelöst durch pl = pv.Plotter()
    
    #Plot Iteration
    _ = plPlot.add_mesh(iter_vtu)
    plPlot.set_viewup([0, 1, 0])
    plPlot.camera.zoom(3)
    plPlot.show(before_close_callback = plotReal)
    
    #Plot Diff
    _ = pl.add_mesh(result_vtu)
#    _ = pl.add_mesh(result_vtu)
    pl.set_viewup([0, 1, 0])
    pl.camera.zoom(3)
    ####pl.show(screenshot = 'diffplot'+iter_fn.format(nriter)+'.png')
    pl.show(before_close_callback = plotDiff)
exit()



    #pl.view_xy()
    #pl.export_obj('diffplot'+iter_fn.format(nriter)+'.obj') #Kann man machen, muss man aber nicht.
    #pl.save_graphic('diffplot'+iter_fn.format(nriter)+'.svg')


#import pyvista as pv
#>>> true_vtu = pv.read('Vp_fwi_m_real.vtu')
#>>> true_vtu_data = pv.read('Vp_fwi_m_real.vtu'

#>>> true_vtu_data = true_vtu.cell_data['Vp']

#>>> true_vtu_data
#pyvista_ndarray([3500., 3500., 3500., ..., 3500., 3500., 3500.],
#                dtype=float32)
#>>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_14.vtu').cell_data['Vp']
#>>> iter_data
#pyvista_ndarray([3500., 3500., 3500., ..., 3500., 3500., 3500.],
#                dtype=float32)
#>>> diff = true_vtu_data-iter_data

#>>> import numpy as np
#>>> diffnp = np.array(diff)
#>>> diffnp
#array([0., 0., 0., ..., 0., 0., 0.], dtype=float32)
#>>> diffnp.norm()
#Traceback (most recent call last):
#  File "<stdin>", line 1, in <module>
#AttributeError: 'numpy.ndarray' object has no attribute 'norm'
#>>> diff.linalg.norm()

#>>> np.linalg.norm(diff)
#9635.88
#>>> initial_data = pv.read('Vp_fwi_m_initial.vtu').cell_data['Vp']
#>>> np.linalg.norm(initial_data-true_vtu_data)
#6858.548
#>>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_1.vtu').cell_data['Vp']
#>>> diff = true_vtu_data-iter_data
#>>> np.linalg.norm(diff)
#8466.148
#>>> np.linalg.norm(diff,ord=2)
##8466.148
#>>> iter_data = pv.read('Vp__fwi_FWISO_iterate_m_allshots_5_0.vtu').cell_data['Vp']
#>>> diff = true_vtu_data-iter_data
#>>> np.linalg.norm(diff,ord=2)
#8278.743
##
